<?php

/* this file has been generated automatically; do not edit */

/**
 * @package Lasso
 */

// Try to load Lasso extension if it's not already loaded.
if (!extension_loaded('lasso')) {
    die("Lasso extension is not loaded");
}

/**
 * @package Lasso
 *
 * Root class of all Lasso objects to define generic getter and setter
 */
class LassoObject {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }
}

/*
 * Convert a C object to a PHP object
 */
function cptrToPhp ($cptr) {
    if (is_null($cptr) || !$cptr) return null;
    $typename = lasso_get_object_typename($cptr);
    $class_name = $typename . "NoInit";
    $obj = new $class_name();
    if (! is_null($obj)) {
        $obj->_cptr = $cptr;
        return $obj;
    }
    return null;
}

function lassoGetRequestTypeFromSoapMsg($mesg) {
    return lasso_get_request_type_from_soap_msg($mesg);
}

function lassoRegisterIdWsf2DstService($prefix, $href) {
    lasso_register_idwsf2_dst_service($prefix, $href);
}

/**
 * @package Lasso
 */
class LassoNode extends LassoObject {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_node_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNode  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_node_new_from_dump($dump));
    }

    /**
     * @return string
     */
    protected function get_originalXmlnode() {
        return lasso_node_get_original_xmlnode($this->_cptr);
    }
    protected function set_originalXmlnode($value) {
        lasso_node_set_original_xmlnode($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_name() {
        return lasso_node_get_name($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_namespace() {
        return lasso_node_get_namespace($this->_cptr);
    }

    /**
     * $this: a LassoNode
     * 
     * Traverse the LassoNode tree starting at Node and remove keeped xmlNode if one is found.
     * 
     * @return  None
     */
    public function cleanupOriginalXmlnodes() {
        return lasso_node_cleanup_original_xmlnodes($this->_cptr);
    }

    /**
     * Dumps $this.  All datas in object are dumped in an XML format.
     * 
     * Return value:(transfer full): a full XML dump of $this.  The string must be freed by the
     *     caller.
     */
    public function dump() {
        return lasso_node_dump($this->_cptr);
    }

    /**
     * Exports $this to a base64-encoded message.
     * 
     * @return string a base64-encoded export of $this.  The string must be freed by
     *      the caller.
     */
    public function exportToBase64() {
        return lasso_node_export_to_base64($this->_cptr);
    }

    /**
     * Exports $this to a HTTP query string.  If $private_key_file is NULL,
     * query won't be signed.
     * 
     * @return string a HTTP query export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToQuery($sign_method = 1, $private_key_file = null) {
        return lasso_node_export_to_query($this->_cptr, $sign_method, $private_key_file);
    }

    /**
     * Exports $this to a HTTP query string.  If $private_key_file is NULL,
     * query won't be signed.
     * 
     * @return string a HTTP query export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToQueryWithPassword($sign_method = 1, $private_key_file = null, $private_key_file_password = null) {
        return lasso_node_export_to_query_with_password($this->_cptr, $sign_method, $private_key_file, $private_key_file_password);
    }

    /**
     * Exports $this to a SOAP message.
     * 
     * @return string a SOAP export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToSoap() {
        return lasso_node_export_to_soap($this->_cptr);
    }

    /**
     * Exports $this to an xml message.
     * 
     * @return string an xml export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToXml() {
        return lasso_node_export_to_xml($this->_cptr);
    }

    /**
     * Exports $this to a PAOS message.
     * 
     * @return string a PAOS export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToPaosRequest($issuer, $responseConsumerURL, $relay_state) {
        return lasso_node_export_to_paos_request($this->_cptr, $issuer, $responseConsumerURL, $relay_state);
    }

    /**
     * Exports $this to a ECP SOAP message.
     * 
     * @return string a ECP SOAP export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToEcpSoapResponse($assertionConsumerURL) {
        return lasso_node_export_to_ecp_soap_response($this->_cptr, $assertionConsumerURL);
    }

    /**
     * Builds an XML representation of $this.
     * 
     * @return string a new xmlNode.  It must be freed by the caller.
     */
    public function getXmlNode($lasso_dump) {
        return lasso_node_get_xmlNode($this->_cptr, $lasso_dump);
    }

    /**
     * Set a custom namespace for an object instance, use it with object existing a lot of revision of
     * the nearly same namespace.
     */
    public function setCustomNamespace($prefix, $href) {
        return lasso_node_set_custom_namespace($this->_cptr, $prefix, $href);
    }

    /**
     * Set a custom nodename for an object instance, use it with object implement a schema type and not
     * a real element.
     */
    public function setCustomNodename($nodename) {
        return lasso_node_set_custom_nodename($this->_cptr, $nodename);
    }

    /**
     * Parses $message and initialiazes $this fields with data from it.  Message
     * type may be base64, SOAP, XML or query string, correct type is found
     * automatically.
     * 
     * @return int a LassoMessageFormat value.
     */
    public function initFromMessage($message) {
        return lasso_node_init_from_message($this->_cptr, $message);
    }

    /**
     * Initialiazes $this fields with data from $query string.
     * 
     * @return boolean TRUE if success
     */
    public function initFromQuery($query) {
        return lasso_node_init_from_query($this->_cptr, $query);
    }

    /**
     * Initialiazes $this fields with data from $xmlnode XML node.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initFromXml($xmlnode) {
        $rc = lasso_node_init_from_xml($this->_cptr, $xmlnode._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Create a debug dump for $this, it is pretty printed so any contained signature will be
     * uncheckable.
     * 
     * Return value:(transfer full): a full indented and so human readable dump of $this. The string must be freed by
     * the caller.
     */
    public function debug($level = 10) {
        return lasso_node_debug($this->_cptr, $level);
    }


}

/**
 * @package Lasso
 */
class LassoNodeNoInit extends LassoNode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpStatus extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_status_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpStatus  failed "); }
    }

    /**'
    * @return LassoSamlpStatusCode
    */
    protected function get_statusCode() {
        $t = LassoSamlpStatus_statusCode_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_statusCode($value) {
        $value = $value->_cptr;
        LassoSamlpStatus_statusCode_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_statusMessage() {
        $t = LassoSamlpStatus_statusMessage_get($this->_cptr);
        return $t;
    }
    protected function set_statusMessage($value) {
        LassoSamlpStatus_statusMessage_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpStatusNoInit extends LassoSamlpStatus {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubject extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_subject_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlSubject  failed "); }
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_nameIdentifier() {
        $t = LassoSamlSubject_nameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdentifier($value) {
        $value = $value->_cptr;
        LassoSamlSubject_nameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlSubjectConfirmation
    */
    protected function get_subjectConfirmation() {
        $t = LassoSamlSubject_subjectConfirmation_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subjectConfirmation($value) {
        $value = $value->_cptr;
        LassoSamlSubject_subjectConfirmation_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedNameIdentifier() {
        $t = LassoSamlSubject_encryptedNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedNameIdentifier($value) {
        $value = $value->_cptr;
        LassoSamlSubject_encryptedNameIdentifier_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectNoInit extends LassoSamlSubject {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibRequestAuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_request_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibRequestAuthnContext  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_authnContextClassRef() {
        $t = LassoLibRequestAuthnContext_authnContextClassRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextClassRef($value) {
        LassoLibRequestAuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_authnContextStatementRef() {
        $t = LassoLibRequestAuthnContext_authnContextStatementRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextStatementRef($value) {
        LassoLibRequestAuthnContext_authnContextStatementRef_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authnContextComparison() {
        $t = LassoLibRequestAuthnContext_authnContextComparison_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextComparison($value) {
        LassoLibRequestAuthnContext_authnContextComparison_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibRequestAuthnContextNoInit extends LassoLibRequestAuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAuthorityBinding extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_authority_binding_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAuthorityBinding  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_authorityKind() {
        $t = LassoSamlAuthorityBinding_authorityKind_get($this->_cptr);
        return $t;
    }
    protected function set_authorityKind($value) {
        LassoSamlAuthorityBinding_authorityKind_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_location() {
        $t = LassoSamlAuthorityBinding_location_get($this->_cptr);
        return $t;
    }
    protected function set_location($value) {
        LassoSamlAuthorityBinding_location_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_binding() {
        $t = LassoSamlAuthorityBinding_binding_get($this->_cptr);
        return $t;
    }
    protected function set_binding($value) {
        LassoSamlAuthorityBinding_binding_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAuthorityBindingNoInit extends LassoSamlAuthorityBinding {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnResponseEnvelope extends LassoNode {
    public $_cptr = null;

    public function __construct($response, $assertionConsumerServiceURL) {
        $this->_cptr = lasso_lib_authn_response_envelope_new($response->_cptr, $assertionConsumerServiceURL);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnResponseEnvelope  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibAuthnResponseEnvelope_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibAuthnResponseEnvelope_extension_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibAuthnResponse
    */
    protected function get_authnResponse() {
        $t = LassoLibAuthnResponseEnvelope_authnResponse_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authnResponse($value) {
        $value = $value->_cptr;
        LassoLibAuthnResponseEnvelope_authnResponse_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionConsumerServiceUrl() {
        $t = LassoLibAuthnResponseEnvelope_assertionConsumerServiceUrl_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerServiceUrl($value) {
        LassoLibAuthnResponseEnvelope_assertionConsumerServiceUrl_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnResponseEnvelopeNoInit extends LassoLibAuthnResponseEnvelope {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlConditions extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_conditions_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlConditions  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_condition() {
        $t = LassoSamlConditions_condition_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_condition($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlConditions_condition_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_audienceRestrictionCondition() {
        $t = LassoSamlConditions_audienceRestrictionCondition_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_audienceRestrictionCondition($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlConditions_audienceRestrictionCondition_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notBefore() {
        $t = LassoSamlConditions_notBefore_get($this->_cptr);
        return $t;
    }
    protected function set_notBefore($value) {
        LassoSamlConditions_notBefore_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notOnOrAfter() {
        $t = LassoSamlConditions_notOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_notOnOrAfter($value) {
        LassoSamlConditions_notOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlConditionsNoInit extends LassoSamlConditions {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoMiscTextNode extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_misc_text_node_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoMiscTextNode  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_content() {
        $t = LassoMiscTextNode_content_get($this->_cptr);
        return $t;
    }
    protected function set_content($value) {
        LassoMiscTextNode_content_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_name() {
        $t = LassoMiscTextNode_name_get($this->_cptr);
        return $t;
    }
    protected function set_name($value) {
        LassoMiscTextNode_name_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_nsHref() {
        $t = LassoMiscTextNode_nsHref_get($this->_cptr);
        return $t;
    }
    protected function set_nsHref($value) {
        LassoMiscTextNode_nsHref_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_nsPrefix() {
        $t = LassoMiscTextNode_nsPrefix_get($this->_cptr);
        return $t;
    }
    protected function set_nsPrefix($value) {
        LassoMiscTextNode_nsPrefix_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_textChild() {
        $t = LassoMiscTextNode_textChild_get($this->_cptr);
        return $t;
    }
    protected function set_textChild($value) {
        LassoMiscTextNode_textChild_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_xmlContent() {
        return lasso_misc_text_node_get_xml_content($this->_cptr);
    }
    protected function set_xmlContent($value) {
        lasso_misc_text_node_set_xml_content($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoMiscTextNodeNoInit extends LassoMiscTextNode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibIDPEntries extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_idp_entries_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibIDPEntries  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_idpEntry() {
        $t = LassoLibIDPEntries_idpEntry_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_idpEntry($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoLibIDPEntries_idpEntry_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibIDPEntriesNoInit extends LassoLibIDPEntries {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectConfirmation extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_subject_confirmation_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlSubjectConfirmation  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_confirmationMethod() {
        $t = LassoSamlSubjectConfirmation_confirmationMethod_get($this->_cptr);
        return $t;
    }
    protected function set_confirmationMethod($value) {
        LassoSamlSubjectConfirmation_confirmationMethod_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_subjectConfirmationData() {
        $t = LassoSamlSubjectConfirmation_subjectConfirmationData_get($this->_cptr);
        return $t;
    }
    protected function set_subjectConfirmationData($value) {
        LassoSamlSubjectConfirmation_subjectConfirmationData_set($this->_cptr, $value);
    }

    /**'
    * @return LassoDsKeyInfo
    */
    protected function get_keyInfo() {
        $t = LassoSamlSubjectConfirmation_keyInfo_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_keyInfo($value) {
        $value = $value->_cptr;
        LassoSamlSubjectConfirmation_keyInfo_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectConfirmationNoInit extends LassoSamlSubjectConfirmation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnRequestEnvelope extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authn_request_envelope_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnRequestEnvelope  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibAuthnRequestEnvelope_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibAuthnRequestEnvelope_extension_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibAuthnRequest
    */
    protected function get_authnRequest() {
        $t = LassoLibAuthnRequestEnvelope_authnRequest_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authnRequest($value) {
        $value = $value->_cptr;
        LassoLibAuthnRequestEnvelope_authnRequest_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibAuthnRequestEnvelope_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibAuthnRequestEnvelope_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerName() {
        $t = LassoLibAuthnRequestEnvelope_providerName_get($this->_cptr);
        return $t;
    }
    protected function set_providerName($value) {
        LassoLibAuthnRequestEnvelope_providerName_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionConsumerServiceUrl() {
        $t = LassoLibAuthnRequestEnvelope_assertionConsumerServiceUrl_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerServiceUrl($value) {
        LassoLibAuthnRequestEnvelope_assertionConsumerServiceUrl_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibIDPList
    */
    protected function get_idpList() {
        $t = LassoLibAuthnRequestEnvelope_idpList_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpList($value) {
        $value = $value->_cptr;
        LassoLibAuthnRequestEnvelope_idpList_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_isPassive() {
        $t = LassoLibAuthnRequestEnvelope_isPassive_get($this->_cptr);
        return $t;
    }
    protected function set_isPassive($value) {
        LassoLibAuthnRequestEnvelope_isPassive_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnRequestEnvelopeNoInit extends LassoLibAuthnRequestEnvelope {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibScoping extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_scoping_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibScoping  failed "); }
    }

    /**'
    * @return int
    */
    protected function get_proxyCount() {
        $t = LassoLibScoping_proxyCount_get($this->_cptr);
        return $t;
    }
    protected function set_proxyCount($value) {
        LassoLibScoping_proxyCount_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibIDPList
    */
    protected function get_idpList() {
        $t = LassoLibScoping_idpList_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpList($value) {
        $value = $value->_cptr;
        LassoLibScoping_idpList_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibScopingNoInit extends LassoLibScoping {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlNameIdentifier extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_name_identifier_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlNameIdentifier  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_nameQualifier() {
        $t = LassoSamlNameIdentifier_nameQualifier_get($this->_cptr);
        return $t;
    }
    protected function set_nameQualifier($value) {
        LassoSamlNameIdentifier_nameQualifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_format() {
        $t = LassoSamlNameIdentifier_format_get($this->_cptr);
        return $t;
    }
    protected function set_format($value) {
        LassoSamlNameIdentifier_format_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_content() {
        $t = LassoSamlNameIdentifier_content_get($this->_cptr);
        return $t;
    }
    protected function set_content($value) {
        LassoSamlNameIdentifier_content_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlNameIdentifierNoInit extends LassoSamlNameIdentifier {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttributeDesignator extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_designator_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttributeDesignator  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_attributeName() {
        $t = LassoSamlAttributeDesignator_attributeName_get($this->_cptr);
        return $t;
    }
    protected function set_attributeName($value) {
        LassoSamlAttributeDesignator_attributeName_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_attributeNamespace() {
        $t = LassoSamlAttributeDesignator_attributeNamespace_get($this->_cptr);
        return $t;
    }
    protected function set_attributeNamespace($value) {
        LassoSamlAttributeDesignator_attributeNamespace_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeDesignatorNoInit extends LassoSamlAttributeDesignator {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttribute extends LassoSamlAttributeDesignator {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttribute  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_attributeName() {
        $t = LassoSamlAttribute_attributeName_get($this->_cptr);
        return $t;
    }
    protected function set_attributeName($value) {
        LassoSamlAttribute_attributeName_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_attributeNameSpace() {
        $t = LassoSamlAttribute_attributeNameSpace_get($this->_cptr);
        return $t;
    }
    protected function set_attributeNameSpace($value) {
        LassoSamlAttribute_attributeNameSpace_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_attributeValue() {
        $t = LassoSamlAttribute_attributeValue_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_attributeValue($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlAttribute_attributeValue_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeNoInit extends LassoSamlAttribute {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDsKeyInfo extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_ds_key_info_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDsKeyInfo  failed "); }
    }

    /**'
    * @return LassoDsKeyValue
    */
    protected function get_keyValue() {
        $t = LassoDsKeyInfo_keyValue_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_keyValue($value) {
        $value = $value->_cptr;
        LassoDsKeyInfo_keyValue_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoDsKeyInfoNoInit extends LassoDsKeyInfo {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDsKeyValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_ds_key_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDsKeyValue  failed "); }
    }

    /**'
    * @return LassoDsRsaKeyValue
    */
    protected function get_rsaKeyValue() {
        $t = LassoDsKeyValue_rsaKeyValue_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_rsaKeyValue($value) {
        $value = $value->_cptr;
        LassoDsKeyValue_rsaKeyValue_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoDsKeyValueNoInit extends LassoDsKeyValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpRequestAbstract extends LassoNode {
    /**'
    * @return array
    */
    protected function get_respondWith() {
        $t = LassoSamlpRequestAbstract_respondWith_get($this->_cptr);
        return $t;
    }
    protected function set_respondWith($value) {
        LassoSamlpRequestAbstract_respondWith_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_requestId() {
        $t = LassoSamlpRequestAbstract_requestId_get($this->_cptr);
        return $t;
    }
    protected function set_requestId($value) {
        LassoSamlpRequestAbstract_requestId_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_majorVersion() {
        $t = LassoSamlpRequestAbstract_majorVersion_get($this->_cptr);
        return $t;
    }
    protected function set_majorVersion($value) {
        LassoSamlpRequestAbstract_majorVersion_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_minorVersion() {
        $t = LassoSamlpRequestAbstract_minorVersion_get($this->_cptr);
        return $t;
    }
    protected function set_minorVersion($value) {
        LassoSamlpRequestAbstract_minorVersion_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issueInstant() {
        $t = LassoSamlpRequestAbstract_issueInstant_get($this->_cptr);
        return $t;
    }
    protected function set_issueInstant($value) {
        LassoSamlpRequestAbstract_issueInstant_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signType() {
        $t = LassoSamlpRequestAbstract_signType_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signType($value) {
        $value = $value->_cptr;
        LassoSamlpRequestAbstract_signType_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signMethod() {
        $t = LassoSamlpRequestAbstract_signMethod_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signMethod($value) {
        $value = $value->_cptr;
        LassoSamlpRequestAbstract_signMethod_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_privateKeyFile() {
        $t = LassoSamlpRequestAbstract_privateKeyFile_get($this->_cptr);
        return $t;
    }
    protected function set_privateKeyFile($value) {
        LassoSamlpRequestAbstract_privateKeyFile_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_certificateFile() {
        $t = LassoSamlpRequestAbstract_certificateFile_get($this->_cptr);
        return $t;
    }
    protected function set_certificateFile($value) {
        LassoSamlpRequestAbstract_certificateFile_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpRequestAbstractNoInit extends LassoSamlpRequestAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_register_name_identifier_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibRegisterNameIdentifierRequest  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibRegisterNameIdentifierRequest_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibRegisterNameIdentifierRequest_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibRegisterNameIdentifierRequest_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibRegisterNameIdentifierRequest_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_idpProvidedNameIdentifier() {
        $t = LassoLibRegisterNameIdentifierRequest_idpProvidedNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpProvidedNameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibRegisterNameIdentifierRequest_idpProvidedNameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_spProvidedNameIdentifier() {
        $t = LassoLibRegisterNameIdentifierRequest_spProvidedNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_spProvidedNameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibRegisterNameIdentifierRequest_spProvidedNameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_oldProvidedNameIdentifier() {
        $t = LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_oldProvidedNameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_relayState() {
        $t = LassoLibRegisterNameIdentifierRequest_relayState_get($this->_cptr);
        return $t;
    }
    protected function set_relayState($value) {
        LassoLibRegisterNameIdentifierRequest_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierRequestNoInit extends LassoLibRegisterNameIdentifierRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authn_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnRequest  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibAuthnRequest_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibAuthnRequest_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibAuthnRequest_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibAuthnRequest_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_affiliationId() {
        $t = LassoLibAuthnRequest_affiliationId_get($this->_cptr);
        return $t;
    }
    protected function set_affiliationId($value) {
        LassoLibAuthnRequest_affiliationId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_nameIdPolicy() {
        $t = LassoLibAuthnRequest_nameIdPolicy_get($this->_cptr);
        return $t;
    }
    protected function set_nameIdPolicy($value) {
        LassoLibAuthnRequest_nameIdPolicy_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_forceAuthn() {
        $t = LassoLibAuthnRequest_forceAuthn_get($this->_cptr);
        return $t;
    }
    protected function set_forceAuthn($value) {
        LassoLibAuthnRequest_forceAuthn_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_isPassive() {
        $t = LassoLibAuthnRequest_isPassive_get($this->_cptr);
        return $t;
    }
    protected function set_isPassive($value) {
        LassoLibAuthnRequest_isPassive_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_protocolProfile() {
        $t = LassoLibAuthnRequest_protocolProfile_get($this->_cptr);
        return $t;
    }
    protected function set_protocolProfile($value) {
        LassoLibAuthnRequest_protocolProfile_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionConsumerServiceId() {
        $t = LassoLibAuthnRequest_assertionConsumerServiceId_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerServiceId($value) {
        LassoLibAuthnRequest_assertionConsumerServiceId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibRequestAuthnContext
    */
    protected function get_requestAuthnContext() {
        $t = LassoLibAuthnRequest_requestAuthnContext_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_requestAuthnContext($value) {
        $value = $value->_cptr;
        LassoLibAuthnRequest_requestAuthnContext_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_relayState() {
        $t = LassoLibAuthnRequest_relayState_get($this->_cptr);
        return $t;
    }
    protected function set_relayState($value) {
        LassoLibAuthnRequest_relayState_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibScoping
    */
    protected function get_scoping() {
        $t = LassoLibAuthnRequest_scoping_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_scoping($value) {
        $value = $value->_cptr;
        LassoLibAuthnRequest_scoping_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoLibAuthnRequest_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoLibAuthnRequest_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnRequestNoInit extends LassoLibAuthnRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpRequest  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_assertionArtifact() {
        $t = LassoSamlpRequest_assertionArtifact_get($this->_cptr);
        return $t;
    }
    protected function set_assertionArtifact($value) {
        LassoSamlpRequest_assertionArtifact_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpRequestNoInit extends LassoSamlpRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectLocality extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_subject_locality_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlSubjectLocality  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_ipAddress() {
        $t = LassoSamlSubjectLocality_ipAddress_get($this->_cptr);
        return $t;
    }
    protected function set_ipAddress($value) {
        LassoSamlSubjectLocality_ipAddress_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_dnsAddress() {
        $t = LassoSamlSubjectLocality_dnsAddress_get($this->_cptr);
        return $t;
    }
    protected function set_dnsAddress($value) {
        LassoSamlSubjectLocality_dnsAddress_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectLocalityNoInit extends LassoSamlSubjectLocality {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttributeValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttributeValue  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_any() {
        $t = LassoSamlAttributeValue_any_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_any($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlAttributeValue_any_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeValueNoInit extends LassoSamlAttributeValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAssertion extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_assertion_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAssertion  failed "); }
    }

    /**'
    * @return LassoSamlConditions
    */
    protected function get_conditions() {
        $t = LassoSamlAssertion_conditions_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_conditions($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_conditions_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlAdvice
    */
    protected function get_advice() {
        $t = LassoSamlAssertion_advice_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_advice($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_advice_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlSubjectStatement
    */
    protected function get_subjectStatement() {
        $t = LassoSamlAssertion_subjectStatement_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subjectStatement($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_subjectStatement_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlAuthenticationStatement
    */
    protected function get_authenticationStatement() {
        $t = LassoSamlAssertion_authenticationStatement_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authenticationStatement($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_authenticationStatement_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlAttributeStatement
    */
    protected function get_attributeStatement() {
        $t = LassoSamlAssertion_attributeStatement_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_attributeStatement($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_attributeStatement_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_majorVersion() {
        $t = LassoSamlAssertion_majorVersion_get($this->_cptr);
        return $t;
    }
    protected function set_majorVersion($value) {
        LassoSamlAssertion_majorVersion_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_minorVersion() {
        $t = LassoSamlAssertion_minorVersion_get($this->_cptr);
        return $t;
    }
    protected function set_minorVersion($value) {
        LassoSamlAssertion_minorVersion_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionId() {
        $t = LassoSamlAssertion_assertionId_get($this->_cptr);
        return $t;
    }
    protected function set_assertionId($value) {
        LassoSamlAssertion_assertionId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issuer() {
        $t = LassoSamlAssertion_issuer_get($this->_cptr);
        return $t;
    }
    protected function set_issuer($value) {
        LassoSamlAssertion_issuer_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issueInstant() {
        $t = LassoSamlAssertion_issueInstant_get($this->_cptr);
        return $t;
    }
    protected function set_issueInstant($value) {
        LassoSamlAssertion_issueInstant_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signType() {
        $t = LassoSamlAssertion_signType_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signType($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_signType_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signMethod() {
        $t = LassoSamlAssertion_signMethod_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signMethod($value) {
        $value = $value->_cptr;
        LassoSamlAssertion_signMethod_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_privateKeyFile() {
        $t = LassoSamlAssertion_privateKeyFile_get($this->_cptr);
        return $t;
    }
    protected function set_privateKeyFile($value) {
        LassoSamlAssertion_privateKeyFile_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_certificateFile() {
        $t = LassoSamlAssertion_certificateFile_get($this->_cptr);
        return $t;
    }
    protected function set_certificateFile($value) {
        LassoSamlAssertion_certificateFile_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAssertionNoInit extends LassoSamlAssertion {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlConditionAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlConditionAbstractNoInit extends LassoSamlConditionAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAudienceRestrictionCondition extends LassoSamlConditionAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_audience_restriction_condition_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAudienceRestrictionCondition  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_audience() {
        $t = LassoSamlAudienceRestrictionCondition_audience_get($this->_cptr);
        return $t;
    }
    protected function set_audience($value) {
        LassoSamlAudienceRestrictionCondition_audience_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAudienceRestrictionConditionNoInit extends LassoSamlAudienceRestrictionCondition {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAssertion extends LassoSamlAssertion {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_assertion_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAssertion  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_inResponseTo() {
        $t = LassoLibAssertion_inResponseTo_get($this->_cptr);
        return $t;
    }
    protected function set_inResponseTo($value) {
        LassoLibAssertion_inResponseTo_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAssertionNoInit extends LassoLibAssertion {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibIDPEntry extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_idp_entry_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibIDPEntry  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibIDPEntry_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibIDPEntry_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerName() {
        $t = LassoLibIDPEntry_providerName_get($this->_cptr);
        return $t;
    }
    protected function set_providerName($value) {
        LassoLibIDPEntry_providerName_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_loc() {
        $t = LassoLibIDPEntry_loc_get($this->_cptr);
        return $t;
    }
    protected function set_loc($value) {
        LassoLibIDPEntry_loc_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibIDPEntryNoInit extends LassoLibIDPEntry {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibLogoutRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_logout_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibLogoutRequest  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibLogoutRequest_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibLogoutRequest_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibLogoutRequest_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibLogoutRequest_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_nameIdentifier() {
        $t = LassoLibLogoutRequest_nameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibLogoutRequest_nameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_sessionIndex() {
        $t = LassoLibLogoutRequest_sessionIndex_get($this->_cptr);
        return $t;
    }
    protected function set_sessionIndex($value) {
        LassoLibLogoutRequest_sessionIndex_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_relayState() {
        $t = LassoLibLogoutRequest_relayState_get($this->_cptr);
        return $t;
    }
    protected function set_relayState($value) {
        LassoLibLogoutRequest_relayState_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoLibLogoutRequest_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoLibLogoutRequest_consent_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notOnOrAfter() {
        $t = LassoLibLogoutRequest_notOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_notOnOrAfter($value) {
        LassoLibLogoutRequest_notOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibLogoutRequestNoInit extends LassoLibLogoutRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnContext  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_authnContextClassRef() {
        $t = LassoLibAuthnContext_authnContextClassRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextClassRef($value) {
        LassoLibAuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authnContextStatementRef() {
        $t = LassoLibAuthnContext_authnContextStatementRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextStatementRef($value) {
        LassoLibAuthnContext_authnContextStatementRef_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnContextNoInit extends LassoLibAuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibSubject extends LassoSamlSubject {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_subject_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibSubject  failed "); }
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_idpProvidedNameIdentifier() {
        $t = LassoLibSubject_idpProvidedNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpProvidedNameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibSubject_idpProvidedNameIdentifier_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibSubjectNoInit extends LassoLibSubject {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDsRsaKeyValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_ds_rsa_key_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDsRsaKeyValue  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_modulus() {
        $t = LassoDsRsaKeyValue_modulus_get($this->_cptr);
        return $t;
    }
    protected function set_modulus($value) {
        LassoDsRsaKeyValue_modulus_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_exponent() {
        $t = LassoDsRsaKeyValue_exponent_get($this->_cptr);
        return $t;
    }
    protected function set_exponent($value) {
        LassoDsRsaKeyValue_exponent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoDsRsaKeyValueNoInit extends LassoDsRsaKeyValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_name_identifier_mapping_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibNameIdentifierMappingRequest  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibNameIdentifierMappingRequest_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibNameIdentifierMappingRequest_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibNameIdentifierMappingRequest_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibNameIdentifierMappingRequest_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_nameIdentifier() {
        $t = LassoLibNameIdentifierMappingRequest_nameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibNameIdentifierMappingRequest_nameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_targetNamespace() {
        $t = LassoLibNameIdentifierMappingRequest_targetNamespace_get($this->_cptr);
        return $t;
    }
    protected function set_targetNamespace($value) {
        LassoLibNameIdentifierMappingRequest_targetNamespace_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoLibNameIdentifierMappingRequest_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoLibNameIdentifierMappingRequest_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingRequestNoInit extends LassoLibNameIdentifierMappingRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpStatusCode extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_status_code_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpStatusCode  failed "); }
    }

    /**'
    * @return LassoSamlpStatusCode
    */
    protected function get_statusCode() {
        $t = LassoSamlpStatusCode_statusCode_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_statusCode($value) {
        $value = $value->_cptr;
        LassoSamlpStatusCode_statusCode_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_value() {
        $t = LassoSamlpStatusCode_value_get($this->_cptr);
        return $t;
    }
    protected function set_value($value) {
        LassoSamlpStatusCode_value_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpStatusCodeNoInit extends LassoSamlpStatusCode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibFederationTerminationNotification extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_federation_termination_notification_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibFederationTerminationNotification  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibFederationTerminationNotification_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibFederationTerminationNotification_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibFederationTerminationNotification_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibFederationTerminationNotification_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_nameIdentifier() {
        $t = LassoLibFederationTerminationNotification_nameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibFederationTerminationNotification_nameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoLibFederationTerminationNotification_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoLibFederationTerminationNotification_consent_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_relayState() {
        $t = LassoLibFederationTerminationNotification_relayState_get($this->_cptr);
        return $t;
    }
    protected function set_relayState($value) {
        LassoLibFederationTerminationNotification_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibFederationTerminationNotificationNoInit extends LassoLibFederationTerminationNotification {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpResponseAbstract extends LassoNode {
    /**'
    * @return string
    */
    protected function get_responseId() {
        $t = LassoSamlpResponseAbstract_responseId_get($this->_cptr);
        return $t;
    }
    protected function set_responseId($value) {
        LassoSamlpResponseAbstract_responseId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_inResponseTo() {
        $t = LassoSamlpResponseAbstract_inResponseTo_get($this->_cptr);
        return $t;
    }
    protected function set_inResponseTo($value) {
        LassoSamlpResponseAbstract_inResponseTo_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_majorVersion() {
        $t = LassoSamlpResponseAbstract_majorVersion_get($this->_cptr);
        return $t;
    }
    protected function set_majorVersion($value) {
        LassoSamlpResponseAbstract_majorVersion_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_minorVersion() {
        $t = LassoSamlpResponseAbstract_minorVersion_get($this->_cptr);
        return $t;
    }
    protected function set_minorVersion($value) {
        LassoSamlpResponseAbstract_minorVersion_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issueInstant() {
        $t = LassoSamlpResponseAbstract_issueInstant_get($this->_cptr);
        return $t;
    }
    protected function set_issueInstant($value) {
        LassoSamlpResponseAbstract_issueInstant_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_recipient() {
        $t = LassoSamlpResponseAbstract_recipient_get($this->_cptr);
        return $t;
    }
    protected function set_recipient($value) {
        LassoSamlpResponseAbstract_recipient_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signType() {
        $t = LassoSamlpResponseAbstract_signType_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signType($value) {
        $value = $value->_cptr;
        LassoSamlpResponseAbstract_signType_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signMethod() {
        $t = LassoSamlpResponseAbstract_signMethod_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signMethod($value) {
        $value = $value->_cptr;
        LassoSamlpResponseAbstract_signMethod_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_privateKeyFile() {
        $t = LassoSamlpResponseAbstract_privateKeyFile_get($this->_cptr);
        return $t;
    }
    protected function set_privateKeyFile($value) {
        LassoSamlpResponseAbstract_privateKeyFile_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_certificateFile() {
        $t = LassoSamlpResponseAbstract_certificateFile_get($this->_cptr);
        return $t;
    }
    protected function set_certificateFile($value) {
        LassoSamlpResponseAbstract_certificateFile_set($this->_cptr, $value);
    }

    public function fill($InResponseTo, $Recipient) {
        return lasso_samlp_response_abstract_fill($this->_cptr, $InResponseTo, $Recipient);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpResponseAbstractNoInit extends LassoSamlpResponseAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingResponse extends LassoSamlpResponseAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_name_identifier_mapping_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibNameIdentifierMappingResponse  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibNameIdentifierMappingResponse_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibNameIdentifierMappingResponse_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibNameIdentifierMappingResponse_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibNameIdentifierMappingResponse_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlpStatus
    */
    protected function get_status() {
        $t = LassoLibNameIdentifierMappingResponse_status_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_status($value) {
        $value = $value->_cptr;
        LassoLibNameIdentifierMappingResponse_status_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_nameIdentifier() {
        $t = LassoLibNameIdentifierMappingResponse_nameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdentifier($value) {
        $value = $value->_cptr;
        LassoLibNameIdentifierMappingResponse_nameIdentifier_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingResponseNoInit extends LassoLibNameIdentifierMappingResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibStatusResponse extends LassoSamlpResponseAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_status_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibStatusResponse  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibStatusResponse_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibStatusResponse_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibStatusResponse_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibStatusResponse_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlpStatus
    */
    protected function get_status() {
        $t = LassoLibStatusResponse_status_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_status($value) {
        $value = $value->_cptr;
        LassoLibStatusResponse_status_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_relayState() {
        $t = LassoLibStatusResponse_relayState_get($this->_cptr);
        return $t;
    }
    protected function set_relayState($value) {
        LassoLibStatusResponse_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibStatusResponseNoInit extends LassoLibStatusResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibLogoutResponse extends LassoLibStatusResponse {
}

/**
 * @package Lasso
 */
class LassoLibLogoutResponseNoInit extends LassoLibLogoutResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierResponse extends LassoLibStatusResponse {
}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierResponseNoInit extends LassoLibRegisterNameIdentifierResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpResponse extends LassoSamlpResponseAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpResponse  failed "); }
    }

    /**'
    * @return LassoSamlpStatus
    */
    protected function get_status() {
        $t = LassoSamlpResponse_status_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_status($value) {
        $value = $value->_cptr;
        LassoSamlpResponse_status_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_assertion() {
        $t = LassoSamlpResponse_assertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlpResponse_assertion_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpResponseNoInit extends LassoSamlpResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnResponse extends LassoSamlpResponse {
    public $_cptr = null;

    public function __construct($providerID, $request) {
        $this->_cptr = lasso_lib_authn_response_new($providerID, $request->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnResponse  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_extension() {
        $t = LassoLibAuthnResponse_extension_get($this->_cptr);
        return $t;
    }
    protected function set_extension($value) {
        LassoLibAuthnResponse_extension_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoLibAuthnResponse_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoLibAuthnResponse_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_relayState() {
        $t = LassoLibAuthnResponse_relayState_get($this->_cptr);
        return $t;
    }
    protected function set_relayState($value) {
        LassoLibAuthnResponse_relayState_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoLibAuthnResponse_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoLibAuthnResponse_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnResponseNoInit extends LassoLibAuthnResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibIDPList extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_idp_list_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibIDPList  failed "); }
    }

    /**'
    * @return LassoLibIDPEntries
    */
    protected function get_idpEntries() {
        $t = LassoLibIDPList_idpEntries_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpEntries($value) {
        $value = $value->_cptr;
        LassoLibIDPList_idpEntries_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_getComplete() {
        $t = LassoLibIDPList_getComplete_get($this->_cptr);
        return $t;
    }
    protected function set_getComplete($value) {
        LassoLibIDPList_getComplete_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibIDPListNoInit extends LassoLibIDPList {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAdvice extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_advice_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAdvice  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_assertionIdReference() {
        $t = LassoSamlAdvice_assertionIdReference_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertionIdReference($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlAdvice_assertionIdReference_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_assertion() {
        $t = LassoSamlAdvice_assertion_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_assertion($value) {
        $value = $value->_cptr;
        LassoSamlAdvice_assertion_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAdviceNoInit extends LassoSamlAdvice {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlStatementAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlStatementAbstractNoInit extends LassoSamlStatementAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatementAbstract extends LassoSamlStatementAbstract {
    /**'
    * @return LassoSamlSubject
    */
    protected function get_subject() {
        $t = LassoSamlSubjectStatementAbstract_subject_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subject($value) {
        $value = $value->_cptr;
        LassoSamlSubjectStatementAbstract_subject_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatementAbstractNoInit extends LassoSamlSubjectStatementAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatement extends LassoSamlSubjectStatementAbstract {
}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatementNoInit extends LassoSamlSubjectStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttributeStatement extends LassoSamlSubjectStatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttributeStatement  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_attribute() {
        $t = LassoSamlAttributeStatement_attribute_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_attribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlAttributeStatement_attribute_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeStatementNoInit extends LassoSamlAttributeStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAuthenticationStatement extends LassoSamlSubjectStatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_authentication_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAuthenticationStatement  failed "); }
    }

    /**'
    * @return LassoSamlSubjectLocality
    */
    protected function get_subjectLocality() {
        $t = LassoSamlAuthenticationStatement_subjectLocality_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subjectLocality($value) {
        $value = $value->_cptr;
        LassoSamlAuthenticationStatement_subjectLocality_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_authorityBinding() {
        $t = LassoSamlAuthenticationStatement_authorityBinding_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_authorityBinding($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlAuthenticationStatement_authorityBinding_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authenticationMethod() {
        $t = LassoSamlAuthenticationStatement_authenticationMethod_get($this->_cptr);
        return $t;
    }
    protected function set_authenticationMethod($value) {
        LassoSamlAuthenticationStatement_authenticationMethod_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authenticationInstant() {
        $t = LassoSamlAuthenticationStatement_authenticationInstant_get($this->_cptr);
        return $t;
    }
    protected function set_authenticationInstant($value) {
        LassoSamlAuthenticationStatement_authenticationInstant_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAuthenticationStatementNoInit extends LassoSamlAuthenticationStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthenticationStatement extends LassoSamlAuthenticationStatement {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authentication_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthenticationStatement  failed "); }
    }

    /**'
    * @return LassoLibAuthnContext
    */
    protected function get_authnContext() {
        $t = LassoLibAuthenticationStatement_authnContext_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authnContext($value) {
        $value = $value->_cptr;
        LassoLibAuthenticationStatement_authnContext_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_reauthenticateOnOrAfter() {
        $t = LassoLibAuthenticationStatement_reauthenticateOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_reauthenticateOnOrAfter($value) {
        LassoLibAuthenticationStatement_reauthenticateOnOrAfter_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_sessionIndex() {
        $t = LassoLibAuthenticationStatement_sessionIndex_get($this->_cptr);
        return $t;
    }
    protected function set_sessionIndex($value) {
        LassoLibAuthenticationStatement_sessionIndex_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthenticationStatementNoInit extends LassoLibAuthenticationStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2StatementAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSaml2StatementAbstractNoInit extends LassoSaml2StatementAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusCode extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_status_code_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2StatusCode  failed "); }
    }

    /**'
    * @return LassoSamlp2StatusCode
    */
    protected function get_statusCode() {
        $t = LassoSamlp2StatusCode_statusCode_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_statusCode($value) {
        $value = $value->_cptr;
        LassoSamlp2StatusCode_statusCode_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_value() {
        $t = LassoSamlp2StatusCode_value_get($this->_cptr);
        return $t;
    }
    protected function set_value($value) {
        LassoSamlp2StatusCode_value_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2StatusCodeNoInit extends LassoSamlp2StatusCode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusDetail extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusDetailNoInit extends LassoSamlp2StatusDetail {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Scoping extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_scoping_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2Scoping  failed "); }
    }

    /**'
    * @return LassoSamlp2IDPList
    */
    protected function get_idpList() {
        $t = LassoSamlp2Scoping_idpList_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpList($value) {
        $value = $value->_cptr;
        LassoSamlp2Scoping_idpList_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_requesterId() {
        $t = LassoSamlp2Scoping_requesterId_get($this->_cptr);
        return $t;
    }
    protected function set_requesterId($value) {
        LassoSamlp2Scoping_requesterId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_proxyCount() {
        $t = LassoSamlp2Scoping_proxyCount_get($this->_cptr);
        return $t;
    }
    protected function set_proxyCount($value) {
        LassoSamlp2Scoping_proxyCount_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ScopingNoInit extends LassoSamlp2Scoping {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AuthnStatement extends LassoSaml2StatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_authn_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AuthnStatement  failed "); }
    }

    /**'
    * @return LassoSaml2SubjectLocality
    */
    protected function get_subjectLocality() {
        $t = LassoSaml2AuthnStatement_subjectLocality_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subjectLocality($value) {
        $value = $value->_cptr;
        LassoSaml2AuthnStatement_subjectLocality_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2AuthnContext
    */
    protected function get_authnContext() {
        $t = LassoSaml2AuthnStatement_authnContext_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authnContext($value) {
        $value = $value->_cptr;
        LassoSaml2AuthnStatement_authnContext_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authnInstant() {
        $t = LassoSaml2AuthnStatement_authnInstant_get($this->_cptr);
        return $t;
    }
    protected function set_authnInstant($value) {
        LassoSaml2AuthnStatement_authnInstant_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_sessionIndex() {
        $t = LassoSaml2AuthnStatement_sessionIndex_get($this->_cptr);
        return $t;
    }
    protected function set_sessionIndex($value) {
        LassoSaml2AuthnStatement_sessionIndex_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_sessionNotOnOrAfter() {
        $t = LassoSaml2AuthnStatement_sessionNotOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_sessionNotOnOrAfter($value) {
        LassoSaml2AuthnStatement_sessionNotOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AuthnStatementNoInit extends LassoSaml2AuthnStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Evidence extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_evidence_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Evidence  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_assertionIdRef() {
        $t = LassoSaml2Evidence_assertionIdRef_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertionIdRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Evidence_assertionIdRef_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_assertionUriRef() {
        $t = LassoSaml2Evidence_assertionUriRef_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertionUriRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Evidence_assertionUriRef_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_assertion() {
        $t = LassoSaml2Evidence_assertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Evidence_assertion_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_encryptedAssertion() {
        $t = LassoSaml2Evidence_encryptedAssertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_encryptedAssertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Evidence_encryptedAssertion_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2EvidenceNoInit extends LassoSaml2Evidence {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Subject extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Subject  failed "); }
    }

    /**'
    * @return LassoSaml2BaseIDAbstract
    */
    protected function get_baseId() {
        $t = LassoSaml2Subject_baseId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_baseId($value) {
        $value = $value->_cptr;
        LassoSaml2Subject_baseId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_nameId() {
        $t = LassoSaml2Subject_nameId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameId($value) {
        $value = $value->_cptr;
        LassoSaml2Subject_nameId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedId() {
        $t = LassoSaml2Subject_encryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedId($value) {
        $value = $value->_cptr;
        LassoSaml2Subject_encryptedId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2SubjectConfirmation
    */
    protected function get_subjectConfirmation() {
        $t = LassoSaml2Subject_subjectConfirmation_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subjectConfirmation($value) {
        $value = $value->_cptr;
        LassoSaml2Subject_subjectConfirmation_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectNoInit extends LassoSaml2Subject {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2RequestAbstract extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_request_abstract_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2RequestAbstract  failed "); }
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_issuer() {
        $t = LassoSamlp2RequestAbstract_issuer_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_issuer($value) {
        $value = $value->_cptr;
        LassoSamlp2RequestAbstract_issuer_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2Extensions
    */
    protected function get_extensions() {
        $t = LassoSamlp2RequestAbstract_extensions_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_extensions($value) {
        $value = $value->_cptr;
        LassoSamlp2RequestAbstract_extensions_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_id() {
        $t = LassoSamlp2RequestAbstract_id_get($this->_cptr);
        return $t;
    }
    protected function set_id($value) {
        LassoSamlp2RequestAbstract_id_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_version() {
        $t = LassoSamlp2RequestAbstract_version_get($this->_cptr);
        return $t;
    }
    protected function set_version($value) {
        LassoSamlp2RequestAbstract_version_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issueInstant() {
        $t = LassoSamlp2RequestAbstract_issueInstant_get($this->_cptr);
        return $t;
    }
    protected function set_issueInstant($value) {
        LassoSamlp2RequestAbstract_issueInstant_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_destination() {
        $t = LassoSamlp2RequestAbstract_destination_get($this->_cptr);
        return $t;
    }
    protected function set_destination($value) {
        LassoSamlp2RequestAbstract_destination_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoSamlp2RequestAbstract_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoSamlp2RequestAbstract_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2RequestAbstractNoInit extends LassoSamlp2RequestAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResolve extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_artifact_resolve_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2ArtifactResolve  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_artifact() {
        $t = LassoSamlp2ArtifactResolve_artifact_get($this->_cptr);
        return $t;
    }
    protected function set_artifact($value) {
        LassoSamlp2ArtifactResolve_artifact_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResolveNoInit extends LassoSamlp2ArtifactResolve {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_authn_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AuthnRequest  failed "); }
    }

    /**'
    * @return LassoSaml2Subject
    */
    protected function get_subject() {
        $t = LassoSamlp2AuthnRequest_subject_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subject($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthnRequest_subject_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2NameIDPolicy
    */
    protected function get_nameIdPolicy() {
        $t = LassoSamlp2AuthnRequest_nameIdPolicy_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdPolicy($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthnRequest_nameIdPolicy_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2Conditions
    */
    protected function get_conditions() {
        $t = LassoSamlp2AuthnRequest_conditions_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_conditions($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthnRequest_conditions_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2RequestedAuthnContext
    */
    protected function get_requestedAuthnContext() {
        $t = LassoSamlp2AuthnRequest_requestedAuthnContext_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_requestedAuthnContext($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthnRequest_requestedAuthnContext_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2Scoping
    */
    protected function get_scoping() {
        $t = LassoSamlp2AuthnRequest_scoping_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_scoping($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthnRequest_scoping_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_forceAuthn() {
        $t = LassoSamlp2AuthnRequest_forceAuthn_get($this->_cptr);
        return $t;
    }
    protected function set_forceAuthn($value) {
        LassoSamlp2AuthnRequest_forceAuthn_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_isPassive() {
        $t = LassoSamlp2AuthnRequest_isPassive_get($this->_cptr);
        return $t;
    }
    protected function set_isPassive($value) {
        LassoSamlp2AuthnRequest_isPassive_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_protocolBinding() {
        $t = LassoSamlp2AuthnRequest_protocolBinding_get($this->_cptr);
        return $t;
    }
    protected function set_protocolBinding($value) {
        LassoSamlp2AuthnRequest_protocolBinding_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_assertionConsumerServiceIndex() {
        $t = LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerServiceIndex($value) {
        LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionConsumerServiceUrl() {
        $t = LassoSamlp2AuthnRequest_assertionConsumerServiceUrl_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerServiceUrl($value) {
        LassoSamlp2AuthnRequest_assertionConsumerServiceUrl_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_attributeConsumingServiceIndex() {
        $t = LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_get($this->_cptr);
        return $t;
    }
    protected function set_attributeConsumingServiceIndex($value) {
        LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_providerName() {
        $t = LassoSamlp2AuthnRequest_providerName_get($this->_cptr);
        return $t;
    }
    protected function set_providerName($value) {
        LassoSamlp2AuthnRequest_providerName_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnRequestNoInit extends LassoSamlp2AuthnRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2ConditionAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSaml2ConditionAbstractNoInit extends LassoSaml2ConditionAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Conditions extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_conditions_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Conditions  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_condition() {
        $t = LassoSaml2Conditions_condition_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_condition($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Conditions_condition_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_audienceRestriction() {
        $t = LassoSaml2Conditions_audienceRestriction_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_audienceRestriction($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Conditions_audienceRestriction_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_oneTimeUse() {
        $t = LassoSaml2Conditions_oneTimeUse_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_oneTimeUse($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Conditions_oneTimeUse_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_proxyRestriction() {
        $t = LassoSaml2Conditions_proxyRestriction_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_proxyRestriction($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Conditions_proxyRestriction_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notBefore() {
        $t = LassoSaml2Conditions_notBefore_get($this->_cptr);
        return $t;
    }
    protected function set_notBefore($value) {
        LassoSaml2Conditions_notBefore_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notOnOrAfter() {
        $t = LassoSaml2Conditions_notOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_notOnOrAfter($value) {
        LassoSaml2Conditions_notOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2ConditionsNoInit extends LassoSaml2Conditions {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDPolicy extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_name_id_policy_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2NameIDPolicy  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_format() {
        $t = LassoSamlp2NameIDPolicy_format_get($this->_cptr);
        return $t;
    }
    protected function set_format($value) {
        LassoSamlp2NameIDPolicy_format_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_spNameQualifier() {
        $t = LassoSamlp2NameIDPolicy_spNameQualifier_get($this->_cptr);
        return $t;
    }
    protected function set_spNameQualifier($value) {
        LassoSamlp2NameIDPolicy_spNameQualifier_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_allowCreate() {
        $t = LassoSamlp2NameIDPolicy_allowCreate_get($this->_cptr);
        return $t;
    }
    protected function set_allowCreate($value) {
        LassoSamlp2NameIDPolicy_allowCreate_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDPolicyNoInit extends LassoSamlp2NameIDPolicy {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AuthnContext  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_authnContextClassRef() {
        $t = LassoSaml2AuthnContext_authnContextClassRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextClassRef($value) {
        LassoSaml2AuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authnContextDeclRef() {
        $t = LassoSaml2AuthnContext_authnContextDeclRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextDeclRef($value) {
        LassoSaml2AuthnContext_authnContextDeclRef_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_authenticatingAuthority() {
        $t = LassoSaml2AuthnContext_authenticatingAuthority_get($this->_cptr);
        return $t;
    }
    protected function set_authenticatingAuthority($value) {
        LassoSaml2AuthnContext_authenticatingAuthority_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AuthnContextNoInit extends LassoSaml2AuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Assertion extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_assertion_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Assertion  failed "); }
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_issuer() {
        $t = LassoSaml2Assertion_issuer_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_issuer($value) {
        $value = $value->_cptr;
        LassoSaml2Assertion_issuer_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2Subject
    */
    protected function get_subject() {
        $t = LassoSaml2Assertion_subject_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subject($value) {
        $value = $value->_cptr;
        LassoSaml2Assertion_subject_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2Conditions
    */
    protected function get_conditions() {
        $t = LassoSaml2Assertion_conditions_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_conditions($value) {
        $value = $value->_cptr;
        LassoSaml2Assertion_conditions_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2Advice
    */
    protected function get_advice() {
        $t = LassoSaml2Assertion_advice_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_advice($value) {
        $value = $value->_cptr;
        LassoSaml2Assertion_advice_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_statement() {
        $t = LassoSaml2Assertion_statement_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_statement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Assertion_statement_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_authnStatement() {
        $t = LassoSaml2Assertion_authnStatement_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_authnStatement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Assertion_authnStatement_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_authzDecisionStatement() {
        $t = LassoSaml2Assertion_authzDecisionStatement_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_authzDecisionStatement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Assertion_authzDecisionStatement_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_attributeStatement() {
        $t = LassoSaml2Assertion_attributeStatement_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_attributeStatement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Assertion_attributeStatement_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_version() {
        $t = LassoSaml2Assertion_version_get($this->_cptr);
        return $t;
    }
    protected function set_version($value) {
        LassoSaml2Assertion_version_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_id() {
        $t = LassoSaml2Assertion_id_get($this->_cptr);
        return $t;
    }
    protected function set_id($value) {
        LassoSaml2Assertion_id_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issueInstant() {
        $t = LassoSaml2Assertion_issueInstant_get($this->_cptr);
        return $t;
    }
    protected function set_issueInstant($value) {
        LassoSaml2Assertion_issueInstant_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_inResponseTo() {
        return lasso_saml2_assertion_get_in_response_to($this->_cptr);
    }

    /**
     * Verify that a LassoSaml2AudienceRestriction is present in the assertion.
     * 
     * @return boolean TRUE if a LassoSaml2AudienceRestriction is present in the Conditions of the
     * LassoSaml2Assertion.
     */
    public function hasAudienceRestriction() {
        return lasso_saml2_assertion_has_audience_restriction($this->_cptr);
    }

    /**
     * Verify that the assertion is restricted to the given providerID.
     * 
     * @return boolean TRUE if $providerID is part of a LassoSaml2AudienceRestriction element in the
     * assertion, FALSE otherwise.
     */
    public function isAudienceRestricted($providerID) {
        return lasso_saml2_assertion_is_audience_restricted($this->_cptr, $providerID);
    }

    /**
     * Set the subject NameID, which can be a simple LassoSaml2NameID object or an encrypted
     * LassoSaml2NameID as a LassoSaml2EncryptedElement.
     */
    public function setSubjectNameId($node) {
        return lasso_saml2_assertion_set_subject_name_id($this->_cptr, $node._cptr);
    }

    /**
     * Set the subject NameID, which can be a simple LassoSaml2NameID object or an encrypted
     * LassoSaml2NameID as a LassoSaml2EncryptedElement.
     */
    public function setSubjectConfirmationNameId($node) {
        return lasso_saml2_assertion_set_subject_confirmation_name_id($this->_cptr, $node._cptr);
    }

    public function setSubjectConfirmationData($tolerance, $length, $Recipient, $InResponseTo, $Address) {
        return lasso_saml2_assertion_set_subject_confirmation_data($this->_cptr, $tolerance._cptr, $length._cptr, $Recipient, $InResponseTo, $Address);
    }

    /**
     * Set conditions limiting usage of the assertion.
     * 
     * $tolerance and $length are time quantity measured in seconds, it defines the time range in which
     * the assertion is valid, it is computed as [now()-tolerance, now()+length+tolerance].
     * $one_time_use allows the issuer to limit caching of the assertion.
     * $proxy_count specify how many proxy hop can be traversed before this assertion should lose any trust.
     * 
     */
    public function setBasicConditions($tolerance = -1, $length = -1, $one_time_use = FALSE) {
        return lasso_saml2_assertion_set_basic_conditions($this->_cptr, $tolerance._cptr, $length._cptr, $one_time_use);
    }

    /**
     * Add an audience restriction to a LassoSaml2Assertion.
     * 
     */
    public function addAudienceRestriction($providerID) {
        return lasso_saml2_assertion_add_audience_restriction($this->_cptr, $providerID);
    }

    /**
     * A LassoSaml2ProxyRestriction to the conditions of consumption of $this.
     */
    public function addProxyLimit($proxy_count = -1, $proxy_audiences = null) {
        return lasso_saml2_assertion_add_proxy_limit($this->_cptr, $proxy_count, $proxy_audiences._cptr);
    }

    /**
     * Check the validation of the assertion with respect to the conditions of consumption that it
     * contains. System functions are used for getting current time and checking eventual time
     * constraints.
     * 
     * @return int LASSO_SAML2_ASSERTION_VALID if the assertion is valid,
     * LASSO_SAML2_ASSERTION_INVALID is some check failed, LASSO_SAML2_ASSERTION_INDETERMINATE if
     * somehting was impossible to eveluate.
     */
    public function validateConditions($relaying_party_providerID = null) {
        return lasso_saml2_assertion_validate_conditions($this->_cptr, $relaying_party_providerID);
    }

    /**
     * Return the LassoProvider object for the provider who created this assertion.
     * 
     * @return LassoProvider a LassoProvider object, or NULL if the Issuer element is missing, or the given
     * provider unknown to the LassoServer object.
     */
    public function getIssuerProvider($server) {
        return lasso_saml2_assertion_get_issuer_provider($this->_cptr, $server._cptr);
    }

    /**
     * Add a new attribute declaration and set this node as the content.
     * 
     * @return lasso_error_t 0 if successful, an error code otherwise.
     */
    public function addAttributeWithNode($name, $nameformat, $content) {
        $rc = lasso_saml2_assertion_add_attribute_with_node($this->_cptr, $name, $nameformat, $content._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    public function getSubjectConfirmationData($create) {
        return lasso_saml2_assertion_get_subject_confirmation_data($this->_cptr, $create);
    }

    /**
     * Decipher (if needed) the EncryptedID of the Subject.
     * 
     * @return lasso_error_t 0 if successful, an error code otherwise. See
     * lasso_saml2_encrypted_element_server_decrypt().
     */
    public function decryptSubject($server) {
        $rc = lasso_saml2_assertion_decrypt_subject($this->_cptr, $server._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Check if the $this conditions about NotBefore and NotOnOrAfter are valid with respect
     * to the $now time or the current time. $tolerance allows to loosely check for validatity, i.e.
     * start time is decreased of $tolerance seconds and end time is increased of $tolerance seconds.
     * 
     * @return int a value among LassoSaml2AssertionValidationState.
     */
    public function validateTimeChecks($tolerance, $now = 0) {
        return lasso_saml2_assertion_validate_time_checks($this->_cptr, $tolerance._cptr, $now._cptr);
    }

    /**
     * Check if the $this is directed to a given $audience.
     * 
     * @return int a value among LassoSaml2AssertionValidationState enumeration.
     */
    public function validateAudience($audience) {
        return lasso_saml2_assertion_validate_audience($this->_cptr, $audience);
    }

    /**
     * Return whether this assertion has the OneTimeUse property.
     * 
     * In this case the relaying party must add the assertion ID to a OneTimeUser cache and discards any
     * assertion received in the future with the same ID.
     * 
     * @return boolean TRUE if this assertion has the property OneTimeUse, FALSE otherwise.
     */
    public function hasOneTimeUse() {
        return lasso_saml2_assertion_has_one_time_use($this->_cptr);
    }

    /**
     * <para>Test whether this $this allows to mint new assertion on the basis of it.</para>
     * <para>It verifies that the proxying count is positive (or absent).</para>
     * 
     * @return int a value among LassoSaml2AssertionValidationState enumeration.
     * LASSO_SAML2_ASSERTION_INDETERMINATE usually means that an element was not conform to the XML
     * Schema for SAML 2.0.
     */
    public function allowsProxying() {
        return lasso_saml2_assertion_allows_proxying($this->_cptr);
    }

    /**
     * <para>Test whether this $this allows to mint new assertion on the basis of it targetted for
     * $audience. </para><para>It verifies that if $audience is
     * non-NULL it is part of the proxy Audience restriction. If $audience is NULL, it checks that no
     * proxying Audience restriction is present.</para>
     * 
     * @return int a value among LassoSaml2AssertionValidationState enumeration.
     * LASSO_SAML2_ASSERTION_INDETERMINATE usually means that an element was not conform to the XML
     * Schema for SAML 2.0.
     */
    public function allowsProxyingTo($audience = null) {
        return lasso_saml2_assertion_allows_proxying_to($this->_cptr, $audience);
    }

    /**
     * Set the one time use condition on this assertion.
     */
    public function setOneTimeUse($one_time_use) {
        return lasso_saml2_assertion_set_one_time_use($this->_cptr, $one_time_use);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AssertionNoInit extends LassoSaml2Assertion {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusResponse extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_status_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2StatusResponse  failed "); }
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_issuer() {
        $t = LassoSamlp2StatusResponse_issuer_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_issuer($value) {
        $value = $value->_cptr;
        LassoSamlp2StatusResponse_issuer_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2Extensions
    */
    protected function get_extensions() {
        $t = LassoSamlp2StatusResponse_extensions_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_extensions($value) {
        $value = $value->_cptr;
        LassoSamlp2StatusResponse_extensions_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2Status
    */
    protected function get_status() {
        $t = LassoSamlp2StatusResponse_status_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_status($value) {
        $value = $value->_cptr;
        LassoSamlp2StatusResponse_status_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_id() {
        $t = LassoSamlp2StatusResponse_id_get($this->_cptr);
        return $t;
    }
    protected function set_id($value) {
        LassoSamlp2StatusResponse_id_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_inResponseTo() {
        $t = LassoSamlp2StatusResponse_inResponseTo_get($this->_cptr);
        return $t;
    }
    protected function set_inResponseTo($value) {
        LassoSamlp2StatusResponse_inResponseTo_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_version() {
        $t = LassoSamlp2StatusResponse_version_get($this->_cptr);
        return $t;
    }
    protected function set_version($value) {
        LassoSamlp2StatusResponse_version_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_issueInstant() {
        $t = LassoSamlp2StatusResponse_issueInstant_get($this->_cptr);
        return $t;
    }
    protected function set_issueInstant($value) {
        LassoSamlp2StatusResponse_issueInstant_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_destination() {
        $t = LassoSamlp2StatusResponse_destination_get($this->_cptr);
        return $t;
    }
    protected function set_destination($value) {
        LassoSamlp2StatusResponse_destination_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_consent() {
        $t = LassoSamlp2StatusResponse_consent_get($this->_cptr);
        return $t;
    }
    protected function set_consent($value) {
        LassoSamlp2StatusResponse_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2StatusResponseNoInit extends LassoSamlp2StatusResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResponse extends LassoSamlp2StatusResponse {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_artifact_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2ArtifactResponse  failed "); }
    }

    /**'
    * @return LassoNode
    */
    protected function get_any() {
        $t = LassoSamlp2ArtifactResponse_any_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_any($value) {
        $value = $value->_cptr;
        LassoSamlp2ArtifactResponse_any_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResponseNoInit extends LassoSamlp2ArtifactResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2NameID extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_name_id_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2NameID  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_content() {
        $t = LassoSaml2NameID_content_get($this->_cptr);
        return $t;
    }
    protected function set_content($value) {
        LassoSaml2NameID_content_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_format() {
        $t = LassoSaml2NameID_format_get($this->_cptr);
        return $t;
    }
    protected function set_format($value) {
        LassoSaml2NameID_format_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_spProvidedId() {
        $t = LassoSaml2NameID_spProvidedId_get($this->_cptr);
        return $t;
    }
    protected function set_spProvidedId($value) {
        LassoSaml2NameID_spProvidedId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_nameQualifier() {
        $t = LassoSaml2NameID_nameQualifier_get($this->_cptr);
        return $t;
    }
    protected function set_nameQualifier($value) {
        LassoSaml2NameID_nameQualifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_spNameQualifier() {
        $t = LassoSaml2NameID_spNameQualifier_get($this->_cptr);
        return $t;
    }
    protected function set_spNameQualifier($value) {
        LassoSaml2NameID_spNameQualifier_set($this->_cptr, $value);
    }

    /**
     * Return TRUE if $this equals $other_name_id.
     * 
     * @return boolean TRUE if the two NameID are equal and are LassoSaml2NameID objects, FALSE
     * otherwise.
     */
    public function equals($other_name_id) {
        return lasso_saml2_name_id_equals($this->_cptr, $other_name_id._cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2NameIDNoInit extends LassoSaml2NameID {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AudienceRestriction extends LassoSaml2ConditionAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_audience_restriction_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AudienceRestriction  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_audience() {
        $t = LassoSaml2AudienceRestriction_audience_get($this->_cptr);
        return $t;
    }
    protected function set_audience($value) {
        LassoSaml2AudienceRestriction_audience_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AudienceRestrictionNoInit extends LassoSaml2AudienceRestriction {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2KeyInfoConfirmationData extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSaml2KeyInfoConfirmationDataNoInit extends LassoSaml2KeyInfoConfirmationData {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_logout_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2LogoutRequest  failed "); }
    }

    /**'
    * @return LassoSaml2BaseIDAbstract
    */
    protected function get_baseId() {
        $t = LassoSamlp2LogoutRequest_baseId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_baseId($value) {
        $value = $value->_cptr;
        LassoSamlp2LogoutRequest_baseId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_nameId() {
        $t = LassoSamlp2LogoutRequest_nameId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameId($value) {
        $value = $value->_cptr;
        LassoSamlp2LogoutRequest_nameId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedId() {
        $t = LassoSamlp2LogoutRequest_encryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedId($value) {
        $value = $value->_cptr;
        LassoSamlp2LogoutRequest_encryptedId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_sessionIndex() {
        $t = LassoSamlp2LogoutRequest_sessionIndex_get($this->_cptr);
        return $t;
    }
    protected function set_sessionIndex($value) {
        LassoSamlp2LogoutRequest_sessionIndex_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_reason() {
        $t = LassoSamlp2LogoutRequest_reason_get($this->_cptr);
        return $t;
    }
    protected function set_reason($value) {
        LassoSamlp2LogoutRequest_reason_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notOnOrAfter() {
        $t = LassoSamlp2LogoutRequest_notOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_notOnOrAfter($value) {
        LassoSamlp2LogoutRequest_notOnOrAfter_set($this->_cptr, $value);
    }

    /**
     * @return array
     */
    protected function get_sessionIndexes() {
        return lasso_samlp2_logout_request_get_session_indexes($this->_cptr);
    }
    protected function set_sessionIndexes($value) {
        lasso_samlp2_logout_request_set_session_indexes($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutRequestNoInit extends LassoSamlp2LogoutRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmationData extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_confirmation_data_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2SubjectConfirmationData  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_notBefore() {
        $t = LassoSaml2SubjectConfirmationData_notBefore_get($this->_cptr);
        return $t;
    }
    protected function set_notBefore($value) {
        LassoSaml2SubjectConfirmationData_notBefore_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_notOnOrAfter() {
        $t = LassoSaml2SubjectConfirmationData_notOnOrAfter_get($this->_cptr);
        return $t;
    }
    protected function set_notOnOrAfter($value) {
        LassoSaml2SubjectConfirmationData_notOnOrAfter_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_recipient() {
        $t = LassoSaml2SubjectConfirmationData_recipient_get($this->_cptr);
        return $t;
    }
    protected function set_recipient($value) {
        LassoSaml2SubjectConfirmationData_recipient_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_inResponseTo() {
        $t = LassoSaml2SubjectConfirmationData_inResponseTo_get($this->_cptr);
        return $t;
    }
    protected function set_inResponseTo($value) {
        LassoSaml2SubjectConfirmationData_inResponseTo_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_address() {
        $t = LassoSaml2SubjectConfirmationData_address_get($this->_cptr);
        return $t;
    }
    protected function set_address($value) {
        LassoSaml2SubjectConfirmationData_address_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmationDataNoInit extends LassoSaml2SubjectConfirmationData {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutResponse extends LassoSamlp2StatusResponse {
}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutResponseNoInit extends LassoSamlp2LogoutResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2SubjectLocality extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_locality_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2SubjectLocality  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_address() {
        $t = LassoSaml2SubjectLocality_address_get($this->_cptr);
        return $t;
    }
    protected function set_address($value) {
        LassoSaml2SubjectLocality_address_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_dnsName() {
        $t = LassoSaml2SubjectLocality_dnsName_get($this->_cptr);
        return $t;
    }
    protected function set_dnsName($value) {
        LassoSaml2SubjectLocality_dnsName_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectLocalityNoInit extends LassoSaml2SubjectLocality {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_manage_name_id_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2ManageNameIDRequest  failed "); }
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_nameId() {
        $t = LassoSamlp2ManageNameIDRequest_nameId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameId($value) {
        $value = $value->_cptr;
        LassoSamlp2ManageNameIDRequest_nameId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedId() {
        $t = LassoSamlp2ManageNameIDRequest_encryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedId($value) {
        $value = $value->_cptr;
        LassoSamlp2ManageNameIDRequest_encryptedId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_newId() {
        $t = LassoSamlp2ManageNameIDRequest_newId_get($this->_cptr);
        return $t;
    }
    protected function set_newId($value) {
        LassoSamlp2ManageNameIDRequest_newId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_newEncryptedId() {
        $t = LassoSamlp2ManageNameIDRequest_newEncryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_newEncryptedId($value) {
        $value = $value->_cptr;
        LassoSamlp2ManageNameIDRequest_newEncryptedId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2Terminate
    */
    protected function get_terminate() {
        $t = LassoSamlp2ManageNameIDRequest_terminate_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_terminate($value) {
        $value = $value->_cptr;
        LassoSamlp2ManageNameIDRequest_terminate_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDRequestNoInit extends LassoSamlp2ManageNameIDRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Response extends LassoSamlp2StatusResponse {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2Response  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_assertion() {
        $t = LassoSamlp2Response_assertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlp2Response_assertion_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_encryptedAssertion() {
        $t = LassoSamlp2Response_encryptedAssertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_encryptedAssertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlp2Response_encryptedAssertion_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ResponseNoInit extends LassoSamlp2Response {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2IDPEntry extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_idp_entry_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2IDPEntry  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoSamlp2IDPEntry_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoSamlp2IDPEntry_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_name() {
        $t = LassoSamlp2IDPEntry_name_get($this->_cptr);
        return $t;
    }
    protected function set_name($value) {
        LassoSamlp2IDPEntry_name_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_loc() {
        $t = LassoSamlp2IDPEntry_loc_get($this->_cptr);
        return $t;
    }
    protected function set_loc($value) {
        LassoSamlp2IDPEntry_loc_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2IDPEntryNoInit extends LassoSamlp2IDPEntry {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_name_id_mapping_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2NameIDMappingRequest  failed "); }
    }

    /**'
    * @return LassoSaml2BaseIDAbstract
    */
    protected function get_baseId() {
        $t = LassoSamlp2NameIDMappingRequest_baseId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_baseId($value) {
        $value = $value->_cptr;
        LassoSamlp2NameIDMappingRequest_baseId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_nameId() {
        $t = LassoSamlp2NameIDMappingRequest_nameId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameId($value) {
        $value = $value->_cptr;
        LassoSamlp2NameIDMappingRequest_nameId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedId() {
        $t = LassoSamlp2NameIDMappingRequest_encryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedId($value) {
        $value = $value->_cptr;
        LassoSamlp2NameIDMappingRequest_encryptedId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2NameIDPolicy
    */
    protected function get_nameIdPolicy() {
        $t = LassoSamlp2NameIDMappingRequest_nameIdPolicy_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdPolicy($value) {
        $value = $value->_cptr;
        LassoSamlp2NameIDMappingRequest_nameIdPolicy_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingRequestNoInit extends LassoSamlp2NameIDMappingRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2IDPList extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_idp_list_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2IDPList  failed "); }
    }

    /**'
    * @return LassoSamlp2IDPEntry
    */
    protected function get_idpEntry() {
        $t = LassoSamlp2IDPList_idpEntry_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_idpEntry($value) {
        $value = $value->_cptr;
        LassoSamlp2IDPList_idpEntry_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_getComplete() {
        $t = LassoSamlp2IDPList_getComplete_get($this->_cptr);
        return $t;
    }
    protected function set_getComplete($value) {
        LassoSamlp2IDPList_getComplete_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2IDPListNoInit extends LassoSamlp2IDPList {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Advice extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_advice_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Advice  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_assertionIdRef() {
        $t = LassoSaml2Advice_assertionIdRef_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertionIdRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Advice_assertionIdRef_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_assertionUriRef() {
        $t = LassoSaml2Advice_assertionUriRef_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertionUriRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Advice_assertionUriRef_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_assertion() {
        $t = LassoSaml2Advice_assertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Advice_assertion_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_encryptedAssertion() {
        $t = LassoSaml2Advice_encryptedAssertion_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_encryptedAssertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Advice_encryptedAssertion_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AdviceNoInit extends LassoSaml2Advice {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2EncryptedElement extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_encrypted_element_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2EncryptedElement  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_encryptedData() {
        $t = LassoSaml2EncryptedElement_encryptedData_get($this->_cptr);
        return $t;
    }
    protected function set_encryptedData($value) {
        LassoSaml2EncryptedElement_encryptedData_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_encryptedKey() {
        $t = LassoSaml2EncryptedElement_encryptedKey_get($this->_cptr);
        return $t;
    }
    protected function set_encryptedKey($value) {
        LassoSaml2EncryptedElement_encryptedKey_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_originalData() {
        $t = LassoSaml2EncryptedElement_originalData_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_originalData($value) {
        $value = $value->_cptr;
        LassoSaml2EncryptedElement_originalData_set($this->_cptr, $value);
    }

    /**
     * Decrypt the given encrypted element using the encryption private key of the $server object
     * 
     * @return lasso_error_t 0 if successful, an error code otherwise. See
     * lasso_saml2_encrypted_element_server_decrypt().
     */
    public function serverDecrypt($server, $decrypted_node) {
        $rc = lasso_saml2_encrypted_element_server_decrypt($this->_cptr, $server._cptr, $decrypted_node);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoSaml2EncryptedElementNoInit extends LassoSaml2EncryptedElement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2SubjectQueryAbstract extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_subject_query_abstract_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2SubjectQueryAbstract  failed "); }
    }

    /**'
    * @return LassoSaml2Subject
    */
    protected function get_subject() {
        $t = LassoSamlp2SubjectQueryAbstract_subject_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subject($value) {
        $value = $value->_cptr;
        LassoSamlp2SubjectQueryAbstract_subject_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2SubjectQueryAbstractNoInit extends LassoSamlp2SubjectQueryAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AuthzDecisionQuery extends LassoSamlp2SubjectQueryAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_authz_decision_query_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AuthzDecisionQuery  failed "); }
    }

    /**'
    * @return LassoSaml2Action
    */
    protected function get_action() {
        $t = LassoSamlp2AuthzDecisionQuery_action_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_action($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthzDecisionQuery_action_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2Evidence
    */
    protected function get_evidence() {
        $t = LassoSamlp2AuthzDecisionQuery_evidence_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_evidence($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthzDecisionQuery_evidence_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_resource() {
        $t = LassoSamlp2AuthzDecisionQuery_resource_get($this->_cptr);
        return $t;
    }
    protected function set_resource($value) {
        LassoSamlp2AuthzDecisionQuery_resource_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AuthzDecisionQueryNoInit extends LassoSamlp2AuthzDecisionQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnQuery extends LassoSamlp2SubjectQueryAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_authn_query_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AuthnQuery  failed "); }
    }

    /**'
    * @return LassoSamlp2RequestedAuthnContext
    */
    protected function get_requestedAuthnContext() {
        $t = LassoSamlp2AuthnQuery_requestedAuthnContext_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_requestedAuthnContext($value) {
        $value = $value->_cptr;
        LassoSamlp2AuthnQuery_requestedAuthnContext_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_sessionIndex() {
        $t = LassoSamlp2AuthnQuery_sessionIndex_get($this->_cptr);
        return $t;
    }
    protected function set_sessionIndex($value) {
        LassoSamlp2AuthnQuery_sessionIndex_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnQueryNoInit extends LassoSamlp2AuthnQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AssertionIDRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_assertion_id_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AssertionIDRequest  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_assertionIdRef() {
        $t = LassoSamlp2AssertionIDRequest_assertionIdRef_get($this->_cptr);
        return $t;
    }
    protected function set_assertionIdRef($value) {
        LassoSamlp2AssertionIDRequest_assertionIdRef_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AssertionIDRequestNoInit extends LassoSamlp2AssertionIDRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2OneTimeUse extends LassoSaml2ConditionAbstract {
}

/**
 * @package Lasso
 */
class LassoSaml2OneTimeUseNoInit extends LassoSaml2OneTimeUse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AttributeValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_attribute_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AttributeValue  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_any() {
        $t = LassoSaml2AttributeValue_any_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_any($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2AttributeValue_any_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AttributeValueNoInit extends LassoSaml2AttributeValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AuthzDecisionStatement extends LassoSaml2StatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_authz_decision_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AuthzDecisionStatement  failed "); }
    }

    /**'
    * @return LassoSaml2Action
    */
    protected function get_action() {
        $t = LassoSaml2AuthzDecisionStatement_action_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_action($value) {
        $value = $value->_cptr;
        LassoSaml2AuthzDecisionStatement_action_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2Evidence
    */
    protected function get_evidence() {
        $t = LassoSaml2AuthzDecisionStatement_evidence_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_evidence($value) {
        $value = $value->_cptr;
        LassoSaml2AuthzDecisionStatement_evidence_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_resource() {
        $t = LassoSaml2AuthzDecisionStatement_resource_get($this->_cptr);
        return $t;
    }
    protected function set_resource($value) {
        LassoSaml2AuthzDecisionStatement_resource_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_decision() {
        $t = LassoSaml2AuthzDecisionStatement_decision_get($this->_cptr);
        return $t;
    }
    protected function set_decision($value) {
        LassoSaml2AuthzDecisionStatement_decision_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AuthzDecisionStatementNoInit extends LassoSaml2AuthzDecisionStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2BaseIDAbstract extends LassoNode {
    /**'
    * @return string
    */
    protected function get_nameQualifier() {
        $t = LassoSaml2BaseIDAbstract_nameQualifier_get($this->_cptr);
        return $t;
    }
    protected function set_nameQualifier($value) {
        LassoSaml2BaseIDAbstract_nameQualifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_spNameQualifier() {
        $t = LassoSaml2BaseIDAbstract_spNameQualifier_get($this->_cptr);
        return $t;
    }
    protected function set_spNameQualifier($value) {
        LassoSaml2BaseIDAbstract_spNameQualifier_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2BaseIDAbstractNoInit extends LassoSaml2BaseIDAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDResponse extends LassoSamlp2StatusResponse {
}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDResponseNoInit extends LassoSamlp2ManageNameIDResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Extensions extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlp2ExtensionsNoInit extends LassoSamlp2Extensions {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AttributeStatement extends LassoSaml2StatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_attribute_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AttributeStatement  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_attribute() {
        $t = LassoSaml2AttributeStatement_attribute_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_attribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2AttributeStatement_attribute_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_encryptedAttribute() {
        $t = LassoSaml2AttributeStatement_encryptedAttribute_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_encryptedAttribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2AttributeStatement_encryptedAttribute_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AttributeStatementNoInit extends LassoSaml2AttributeStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2ProxyRestriction extends LassoSaml2ConditionAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_proxy_restriction_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2ProxyRestriction  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_audience() {
        $t = LassoSaml2ProxyRestriction_audience_get($this->_cptr);
        return $t;
    }
    protected function set_audience($value) {
        LassoSaml2ProxyRestriction_audience_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_count() {
        $t = LassoSaml2ProxyRestriction_count_get($this->_cptr);
        return $t;
    }
    protected function set_count($value) {
        LassoSaml2ProxyRestriction_count_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2ProxyRestrictionNoInit extends LassoSaml2ProxyRestriction {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmation extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_confirmation_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2SubjectConfirmation  failed "); }
    }

    /**'
    * @return LassoSaml2BaseIDAbstract
    */
    protected function get_baseId() {
        $t = LassoSaml2SubjectConfirmation_baseId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_baseId($value) {
        $value = $value->_cptr;
        LassoSaml2SubjectConfirmation_baseId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_nameId() {
        $t = LassoSaml2SubjectConfirmation_nameId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameId($value) {
        $value = $value->_cptr;
        LassoSaml2SubjectConfirmation_nameId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedId() {
        $t = LassoSaml2SubjectConfirmation_encryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedId($value) {
        $value = $value->_cptr;
        LassoSaml2SubjectConfirmation_encryptedId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2SubjectConfirmationData
    */
    protected function get_subjectConfirmationData() {
        $t = LassoSaml2SubjectConfirmation_subjectConfirmationData_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_subjectConfirmationData($value) {
        $value = $value->_cptr;
        LassoSaml2SubjectConfirmation_subjectConfirmationData_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_method() {
        $t = LassoSaml2SubjectConfirmation_method_get($this->_cptr);
        return $t;
    }
    protected function set_method($value) {
        LassoSaml2SubjectConfirmation_method_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmationNoInit extends LassoSaml2SubjectConfirmation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2RequestedAuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_requested_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2RequestedAuthnContext  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_authnContextClassRef() {
        $t = LassoSamlp2RequestedAuthnContext_authnContextClassRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextClassRef($value) {
        LassoSamlp2RequestedAuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_authnContextDeclRef() {
        $t = LassoSamlp2RequestedAuthnContext_authnContextDeclRef_get($this->_cptr);
        return $t;
    }
    protected function set_authnContextDeclRef($value) {
        LassoSamlp2RequestedAuthnContext_authnContextDeclRef_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_comparison() {
        $t = LassoSamlp2RequestedAuthnContext_comparison_get($this->_cptr);
        return $t;
    }
    protected function set_comparison($value) {
        LassoSamlp2RequestedAuthnContext_comparison_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2RequestedAuthnContextNoInit extends LassoSamlp2RequestedAuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Attribute extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_attribute_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Attribute  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_attributeValue() {
        $t = LassoSaml2Attribute_attributeValue_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_attributeValue($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSaml2Attribute_attributeValue_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_name() {
        $t = LassoSaml2Attribute_name_get($this->_cptr);
        return $t;
    }
    protected function set_name($value) {
        LassoSaml2Attribute_name_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_nameFormat() {
        $t = LassoSaml2Attribute_nameFormat_get($this->_cptr);
        return $t;
    }
    protected function set_nameFormat($value) {
        LassoSaml2Attribute_nameFormat_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_friendlyName() {
        $t = LassoSaml2Attribute_friendlyName_get($this->_cptr);
        return $t;
    }
    protected function set_friendlyName($value) {
        LassoSaml2Attribute_friendlyName_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AttributeNoInit extends LassoSaml2Attribute {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AttributeQuery extends LassoSamlp2SubjectQueryAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_attribute_query_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AttributeQuery  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_attribute() {
        $t = LassoSamlp2AttributeQuery_attribute_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_attribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSamlp2AttributeQuery_attribute_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AttributeQueryNoInit extends LassoSamlp2AttributeQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Status extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_status_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2Status  failed "); }
    }

    /**'
    * @return LassoSamlp2StatusCode
    */
    protected function get_statusCode() {
        $t = LassoSamlp2Status_statusCode_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_statusCode($value) {
        $value = $value->_cptr;
        LassoSamlp2Status_statusCode_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_statusMessage() {
        $t = LassoSamlp2Status_statusMessage_get($this->_cptr);
        return $t;
    }
    protected function set_statusMessage($value) {
        LassoSamlp2Status_statusMessage_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSamlp2StatusDetail
    */
    protected function get_statusDetail() {
        $t = LassoSamlp2Status_statusDetail_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_statusDetail($value) {
        $value = $value->_cptr;
        LassoSamlp2Status_statusDetail_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2StatusNoInit extends LassoSamlp2Status {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Action extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_action_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Action  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_content() {
        $t = LassoSaml2Action_content_get($this->_cptr);
        return $t;
    }
    protected function set_content($value) {
        LassoSaml2Action_content_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_namespace() {
        $t = LassoSaml2Action_namespace_get($this->_cptr);
        return $t;
    }
    protected function set_namespace($value) {
        LassoSaml2Action_namespace_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2ActionNoInit extends LassoSaml2Action {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingResponse extends LassoSamlp2StatusResponse {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_name_id_mapping_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2NameIDMappingResponse  failed "); }
    }

    /**'
    * @return LassoSaml2NameID
    */
    protected function get_nameId() {
        $t = LassoSamlp2NameIDMappingResponse_nameId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameId($value) {
        $value = $value->_cptr;
        LassoSamlp2NameIDMappingResponse_nameId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSaml2EncryptedElement
    */
    protected function get_encryptedId() {
        $t = LassoSamlp2NameIDMappingResponse_encryptedId_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_encryptedId($value) {
        $value = $value->_cptr;
        LassoSamlp2NameIDMappingResponse_encryptedId_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingResponseNoInit extends LassoSamlp2NameIDMappingResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Terminate extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlp2TerminateNoInit extends LassoSamlp2Terminate {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSoapEnvelope extends LassoNode {
    public $_cptr = null;

    public function __construct($body) {
        $this->_cptr = lasso_soap_envelope_new($body->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSoapEnvelope  failed "); }
    }

    /**'
    * @return LassoSoapHeader
    */
    protected function get_header() {
        $t = LassoSoapEnvelope_header_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_header($value) {
        $value = $value->_cptr;
        LassoSoapEnvelope_header_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSoapBody
    */
    protected function get_body() {
        $t = LassoSoapEnvelope_body_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_body($value) {
        $value = $value->_cptr;
        LassoSoapEnvelope_body_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSoapEnvelopeNoInit extends LassoSoapEnvelope {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSoapFault extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_soap_fault_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSoapFault  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_faultcode() {
        $t = LassoSoapFault_faultcode_get($this->_cptr);
        return $t;
    }
    protected function set_faultcode($value) {
        LassoSoapFault_faultcode_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_faultstring() {
        $t = LassoSoapFault_faultstring_get($this->_cptr);
        return $t;
    }
    protected function set_faultstring($value) {
        LassoSoapFault_faultstring_set($this->_cptr, $value);
    }

    /**'
    * @return array
    */
    protected function get_faultactor() {
        $t = LassoSoapFault_faultactor_get($this->_cptr);
        return $t;
    }
    protected function set_faultactor($value) {
        LassoSoapFault_faultactor_set($this->_cptr, $value);
    }

    /**'
    * @return LassoSoapDetail
    */
    protected function get_detail() {
        $t = LassoSoapFault_detail_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_detail($value) {
        $value = $value->_cptr;
        LassoSoapFault_detail_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSoapFaultNoInit extends LassoSoapFault {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSoapDetail extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_soap_detail_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSoapDetail  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_any() {
        $t = LassoSoapDetail_any_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_any($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSoapDetail_any_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSoapDetailNoInit extends LassoSoapDetail {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSoapBody extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_soap_body_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSoapBody  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_any() {
        $t = LassoSoapBody_any_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_any($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSoapBody_any_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_id() {
        $t = LassoSoapBody_id_get($this->_cptr);
        return $t;
    }
    protected function set_id($value) {
        LassoSoapBody_id_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSoapBodyNoInit extends LassoSoapBody {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSoapHeader extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_soap_header_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSoapHeader  failed "); }
    }

    /**'
    * @return array
    */
    protected function get_other() {
        $t = LassoSoapHeader_other_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_other($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSoapHeader_other_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSoapHeaderNoInit extends LassoSoapHeader {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoFederation extends LassoNode {
    public $_cptr = null;

    public function __construct($remote_providerID) {
        $this->_cptr = lasso_federation_new($remote_providerID);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoFederation  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_remoteProviderId() {
        $t = LassoFederation_remoteProviderId_get($this->_cptr);
        return $t;
    }
    protected function set_remoteProviderId($value) {
        LassoFederation_remoteProviderId_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_localNameIdentifier() {
        $t = LassoFederation_localNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_localNameIdentifier($value) {
        $value = $value->_cptr;
        LassoFederation_localNameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_remoteNameIdentifier() {
        $t = LassoFederation_remoteNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_remoteNameIdentifier($value) {
        $value = $value->_cptr;
        LassoFederation_remoteNameIdentifier_set($this->_cptr, $value);
    }

    /**
     * Builds federation local name identifier.
     */
    public function buildLocalNameIdentifier($nameQualifier, $format, $content) {
        return lasso_federation_build_local_name_identifier($this->_cptr, $nameQualifier, $format, $content);
    }

    /**
     * Checks whether federation is for $name_identifier.
     * 
     * @return boolean TRUE if the federation is for $name_identifier.
     */
    public function verifyNameIdentifier($name_identifier) {
        return lasso_federation_verify_name_identifier($this->_cptr, $name_identifier._cptr);
    }


}

/**
 * @package Lasso
 */
class LassoFederationNoInit extends LassoFederation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoIdentity extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_identity_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoIdentity  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_identity_new_from_dump($dump));
    }

    /**'
    * @return array
    */
    protected function get_federations() {
        $t = LassoIdentity_federations_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_federations($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoIdentity_federations_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_isDirty() {
        $t = LassoIdentity_isDirty_get($this->_cptr);
        return $t;
    }
    protected function set_isDirty($value) {
        LassoIdentity_isDirty_set($this->_cptr, $value);
    }

    /**
     * Looks up and returns the LassoFederation for this provider ID.
     * 
     * Return value:(transfer none): the LassoFederation; or NULL if it didn't exist.  The
     *      LassoFederation is internally allocated.  It must not be freed,
     *      modified or stored.
     */
    public function getFederation($providerID) {
        return lasso_identity_get_federation($this->_cptr, $providerID);
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_identity_dump($this->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoIdentityNoInit extends LassoIdentity {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoProvider extends LassoNode {
    public $_cptr = null;

    public function __construct($role, $metadata, $public_key = null, $ca_cert_chain = null) {
        $this->_cptr = lasso_provider_new($role, $metadata, $public_key, $ca_cert_chain);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoProvider  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_provider_new_from_dump($dump));
    }

    /**'
    * @return string
    */
    protected function get_providerId() {
        $t = LassoProvider_providerId_get($this->_cptr);
        return $t;
    }
    protected function set_providerId($value) {
        LassoProvider_providerId_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_role() {
        $t = LassoProvider_role_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_role($value) {
        $value = $value->_cptr;
        LassoProvider_role_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_metadataFilename() {
        $t = LassoProvider_metadataFilename_get($this->_cptr);
        return $t;
    }
    protected function set_metadataFilename($value) {
        LassoProvider_metadataFilename_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_publicKey() {
        $t = LassoProvider_publicKey_get($this->_cptr);
        return $t;
    }
    protected function set_publicKey($value) {
        LassoProvider_publicKey_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_caCertChain() {
        $t = LassoProvider_caCertChain_get($this->_cptr);
        return $t;
    }
    protected function set_caCertChain($value) {
        LassoProvider_caCertChain_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_base64SuccinctId() {
        return lasso_provider_get_base64_succinct_id($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_organization() {
        return lasso_provider_get_organization($this->_cptr);
    }

    /**
     * @return int
     */
    protected function get_protocolConformance() {
        return lasso_provider_get_protocol_conformance($this->_cptr);
    }

    /**
     * @return int
     */
    protected function get_encryptionMode() {
        return lasso_provider_get_encryption_mode($this->_cptr);
    }
    protected function set_encryptionMode($value) {
        lasso_provider_set_encryption_mode($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_defaultNameIdFormat() {
        return lasso_provider_get_default_name_id_format($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_spNameQualifier() {
        return lasso_provider_get_sp_name_qualifier($this->_cptr);
    }

    /**
     * @return array
     */
    protected function get_idpSupportedAttributes() {
        return lasso_provider_get_idp_supported_attributes($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_validUntil() {
        return lasso_provider_get_valid_until($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_cacheDuration() {
        return lasso_provider_get_cache_duration($this->_cptr);
    }

    /**
     * @return int
     */
    protected function get_roles() {
        return lasso_provider_get_roles($this->_cptr);
    }

    /**
     * Dump the node object to an XML fragment, then encrypt this fragment using encryption key of
     * $this, then encapsulate the resulting encrypted content into a LassoSaml2EncryptedElement.
     * 
     * @return LassoSaml2EncryptedElement a newly created LassoSaml2EncryptedElement if successfull, NULL otherwise.
     */
    public function saml2NodeEncrypt($lasso_node) {
        return lasso_provider_saml2_node_encrypt($this->_cptr, $lasso_node._cptr);
    }

    /**
     * Extracts the AssertionConsumerServiceURL from the provider metadata
     * descriptor.
     * 
     * Return value:(allow-none)(transfer full): the element value, NULL if the element was not found.  This
     *      string must be freed by the caller.
     */
    public function getAssertionConsumerServiceUrl($service_id = null) {
        return lasso_provider_get_assertion_consumer_service_url($this->_cptr, $service_id);
    }

    /**
     * Extracts the element $name from the provider metadata descriptor.
     * 
     * Return value:(transfer full)(allow-none): the element value, NULL if the element was not found.
     * This string must be freed by the caller.
     */
    public function getMetadataOne($name) {
        return lasso_provider_get_metadata_one($this->_cptr, $name);
    }

    /**
     * Extracts zero to many elements from the provider metadata descriptor.
     * 
     * Return value:(transfer none)(element-type string): a GList with the elements.  This GList is internally
     *      allocated and points to internally allocated strings.  It must
     *      not be freed, modified or stored.
     */
    public function getMetadataList($name) {
        return lasso_provider_get_metadata_list($this->_cptr, $name);
    }

    /**
     * Looks up and returns a LassoHttpMethod appropriate for performing the
     * $protocol_type between $this and $remote_provider.
     * 
     * @return int the LassoHttpMethod
     */
    public function getFirstHttpMethod($remote_provider, $protocol_type) {
        return lasso_provider_get_first_http_method($this->_cptr, $remote_provider._cptr, $protocol_type);
    }

    /**
     * Gets if $http_method is an appropriate method for the $protocol_type profile
     * between $this and $remote_provider.
     * 
     * @return boolean TRUE if it is appropriate
     */
    public function acceptHttpMethod($remote_provider, $protocol_type, $http_method, $initiate_profile) {
        return lasso_provider_accept_http_method($this->_cptr, $remote_provider._cptr, $protocol_type, $http_method, $initiate_profile);
    }

    /**
     * Gets if $this supports $protocol_profile.
     * 
     * @return boolean TRUE if it is supported
     */
    public function hasProtocolProfile($protocol_type, $protocol_profile) {
        return lasso_provider_has_protocol_profile($this->_cptr, $protocol_type, $protocol_profile);
    }

    /**
     * Set the type of the generated encryption symetric key
     */
    public function setEncryptionSymKeyType($encryption_sym_key_type) {
        return lasso_provider_set_encryption_sym_key_type($this->_cptr, $encryption_sym_key_type);
    }

    /**
     * Return wheter the provider signed this node.
     * 
     * @return lasso_error_t 0 if the node is signed by this provider, an error code otherwise.
     */
    public function verifySingleNodeSignature($node, $id_attr_name) {
        $rc = lasso_provider_verify_single_node_signature($this->_cptr, $node._cptr, $id_attr_name);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Return the given information extracted from the metadata of the given LassoProvider for the
     * given $role descriptor.
     * 
     * Retun value: a newly allocated string or NULL. If non-NULL must be freed by the caller.
     */
    public function getMetadataOneForRole($role, $name) {
        return lasso_provider_get_metadata_one_for_role($this->_cptr, $role, $name);
    }

    /**
     * Extracts zero to many elements from the $this descriptor for the given $role.
     * 
     * Return value:(transfer none)(element-type string): a GList with the elements.  This GList is internally
     *      allocated and points to internally allocated strings.  It must
     *      not be freed, modified or stored.
     */
    public function getMetadataListForRole($role, $name) {
        return lasso_provider_get_metadata_list_for_role($this->_cptr, $role, $name);
    }

    /**
     * Returns the list of metadata keys existing for the given provider.
     * 
     * Return value:(element-type utf8)(transfer full): a newly allocated list of strings
     */
    public function getMetadataKeysForRole($role) {
        return lasso_provider_get_metadata_keys_for_role($this->_cptr, $role);
    }

    /**
     * Return whether the two provider support a same protocol.
     * See also LassoProtocolConformance.
     * 
     * @return boolean TRUE or FALSE.
     */
    public function matchConformance($another_provider) {
        return lasso_provider_match_conformance($this->_cptr, $another_provider._cptr);
    }


}

/**
 * @package Lasso
 */
class LassoProviderNoInit extends LassoProvider {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSession extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_session_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSession  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_session_new_from_dump($dump));
    }

    /**'
    * @return array
    */
    protected function get_assertions() {
        $t = LassoSession_assertions_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_assertions($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoSession_assertions_set($this->_cptr, $value);
    }

    /**'
    * @return boolean
    */
    protected function get_isDirty() {
        $t = LassoSession_isDirty_get($this->_cptr);
        return $t;
    }
    protected function set_isDirty($value) {
        LassoSession_isDirty_set($this->_cptr, $value);
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_session_dump($this->_cptr);
    }

    /**
     * Gets the assertions for the given $provider_id.
     * 
     * Return value:(allow-none)(transfer container) (element-type LassoNode): a list of LassoSamlAssertion.
     */
    public function getAssertions($provider_id = null) {
        return lasso_session_get_assertions($this->_cptr, $provider_id);
    }

    /**
     * Looks up and returns the nth provider id.
     * 
     * Return value:(transfer full)(allow-none): the provider id; or NULL if there were no nth provider.  This
     *      string must be freed by the caller.
     */
    public function getProviderIndex($index) {
        return lasso_session_get_provider_index($this->_cptr, $index);
    }

    /**
     * Returns TRUE if session is empty.
     * 
     * @return boolean TRUE if empty
     */
    public function isEmpty() {
        return lasso_session_is_empty($this->_cptr);
    }

    /**
     * Removes assertion for $providerID from $this.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function removeAssertion($providerID) {
        $rc = lasso_session_remove_assertion($this->_cptr, $providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Gets the assertion for the given $providerID.
     * 
     * Return value:(transfer none)(allow-none): the assertion or NULL if it didn't exist.  This
     *      LassoSamlAssertion is internally allocated and must not be freed by
     *      the caller.
     */
    public function getAssertion($providerID) {
        return lasso_session_get_assertion($this->_cptr, $providerID);
    }

    /**
     * Adds $assertion to the principal session. This function also
     * add the assertion to the index by assertionID.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function addAssertion($providerID, $assertion) {
        $rc = lasso_session_add_assertion($this->_cptr, $providerID, $assertion._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoSessionNoInit extends LassoSession {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoProfile extends LassoNode {
    /**'
    * @return LassoServer
    */
    protected function get_server() {
        $t = LassoProfile_server_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_server($value) {
        $value = $value->_cptr;
        LassoProfile_server_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_request() {
        $t = LassoProfile_request_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_request($value) {
        $value = $value->_cptr;
        LassoProfile_request_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_response() {
        $t = LassoProfile_response_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_response($value) {
        $value = $value->_cptr;
        LassoProfile_response_set($this->_cptr, $value);
    }

    /**'
    * @return LassoNode
    */
    protected function get_nameIdentifier() {
        $t = LassoProfile_nameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_nameIdentifier($value) {
        $value = $value->_cptr;
        LassoProfile_nameIdentifier_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_remoteProviderId() {
        $t = LassoProfile_remoteProviderId_get($this->_cptr);
        return $t;
    }
    protected function set_remoteProviderId($value) {
        LassoProfile_remoteProviderId_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_msgUrl() {
        $t = LassoProfile_msgUrl_get($this->_cptr);
        return $t;
    }
    protected function set_msgUrl($value) {
        LassoProfile_msgUrl_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_msgBody() {
        $t = LassoProfile_msgBody_get($this->_cptr);
        return $t;
    }
    protected function set_msgBody($value) {
        LassoProfile_msgBody_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_msgRelayState() {
        $t = LassoProfile_msgRelayState_get($this->_cptr);
        return $t;
    }
    protected function set_msgRelayState($value) {
        LassoProfile_msgRelayState_set($this->_cptr, $value);
    }

    /**
     * @return LassoIdentity
     */
    protected function get_identity() {
        $cptr = lasso_profile_get_identity($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * @return LassoSession
     */
    protected function get_session() {
        $cptr = lasso_profile_get_session($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * @return LassoNode
     */
    protected function get_federationNameIdentifier() {
        $cptr = lasso_profile_get_federation_nameIdentifier($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * @return string
     */
    protected function get_artifact() {
        return lasso_profile_get_artifact($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_artifactMessage() {
        return lasso_profile_get_artifact_message($this->_cptr);
    }
    protected function set_artifactMessage($value) {
        lasso_profile_set_artifact_message($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signatureHint() {
        return lasso_profile_get_signature_hint($this->_cptr);
    }
    protected function set_signatureHint($value) {
        lasso_profile_set_signature_hint($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signatureVerifyHint() {
        return lasso_profile_get_signature_verify_hint($this->_cptr);
    }
    protected function set_signatureVerifyHint($value) {
        lasso_profile_set_signature_verify_hint($this->_cptr, $value);
    }

    /**
     * @return lasso_error_t
     */
    protected function get_signatureStatus() {
        return lasso_profile_get_signature_status($this->_cptr);
    }

    /**
     * Checks whether identity has been modified (and should therefore be saved).
     * 
     * @return boolean TRUE if identity has changed
     */
    public function hasDirtyIdentity() {
        return lasso_profile_has_dirty_identity($this->_cptr);
    }

    /**
     * Checks whether session has been modified (and should therefore be saved).
     * 
     * @return boolean TRUE if session has changed
     */
    public function hasDirtySession() {
        return lasso_profile_has_dirty_session($this->_cptr);
    }

    /**
     * Builds a new LassoIdentity object from XML dump and binds it to $this.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function setIdentityFromDump($dump) {
        $rc = lasso_profile_set_identity_from_dump($this->_cptr, $dump);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds a new LassoSession object from XML dump and binds it to $this.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function setSessionFromDump($dump) {
        $rc = lasso_profile_set_session_from_dump($this->_cptr, $dump);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Set the response to a SOAP fault, using $faultcode, $faultstring, and $details to initialize it.
     * 
     * @return lasso_error_t 0 if successful, an error code otherwise.
     */
    public function setSoapFaultResponse($faultcode, $faultstring = null, $details = null) {
        $rc = lasso_profile_set_soap_fault_response($this->_cptr, $faultcode, $faultstring, $details._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Returns whether the current provider is a service provider relatively to another provider. It
     * uses the LassoProfile.identity to find if a federation qualifier by the given provider exists or
     * the reverse.
     * 
     * @return int LASSO_PROVIDER_ROLE_NONE if nothing can be said, LASSO_PROVIDER_ROLE_SP if a
     * federation qualifier by $remote_provider_id exists or LASSO_PROVIDER_ROLE_IDP if a federation
     * qualifier by our own LassoProvider.providerID exists.
     */
    public function ssoRoleWith($remote_provider_id) {
        return lasso_profile_sso_role_with($this->_cptr, $remote_provider_id);
    }


}

/**
 * @package Lasso
 */
class LassoProfileNoInit extends LassoProfile {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoAssertionQuery extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_assertion_query_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoAssertionQuery  failed "); }
    }

    /**
     * @return int
     */
    protected function get_requestType() {
        return lasso_assertion_query_get_request_type($this->_cptr);
    }

    /**
     * Initializes a new Assertion Query Request.
     * For the AssertionID request type, the remote_provider_id is mandatory, for all other kind of
     * request it is optional if we can find a provider supporting the associated role, i.e.
     * IDP; authentication, attribute and authorization authority.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_provider_id = null, $http_method, $query_request_type) {
        $rc = lasso_assertion_query_init_request($this->_cptr, $remote_provider_id, $http_method, $query_request_type);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Assertion query or request; caller must add assertions to the
     * response afterwards.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_assertion_query_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Build an Assertion Query profile request message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_assertion_query_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Assertion query or request message.  Rebuilds a request object
     * from the message and check its signature.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_assertion_query_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Response message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_assertion_query_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Parses the response message and builds the corresponding response object.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_assertion_query_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Append a new attribute designator to the current attribute request.
     * 
     * @return lasso_error_t 0 if successful, an error code otherwise.
     */
    public function addAttributeRequest($format, $name) {
        $rc = lasso_assertion_query_add_attribute_request($this->_cptr, $format, $name);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoAssertionQueryNoInit extends LassoAssertionQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoNameIdManagement extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_name_id_management_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNameIdManagement  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_name_id_management_new_from_dump($server->_cptr, $dump));
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_name_id_management_dump($this->_cptr);
    }

    /**
     * Initializes a new Name Id Management Request. If $new_name_id is NULL, it is a Termination
     * request, if not and we are an IdP is a NameID change request, if we are a SP, it is a request to
     * add a SP provided Id to the NameID of the IdP. It can be useful if the SP do not want to store
     * the federation, instead he can export its own identifiers to the IdP.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_provider_id = null, $new_name_id = null, $http_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_name_id_management_init_request($this->_cptr, $remote_provider_id, $new_name_id, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Name Id Management request message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_name_id_management_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Name Id Management request message.  Rebuilds a request object
     * from the message and check its signature.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_name_id_management_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Name Id Management request, performing requested actions against
     * principal federations.  Profile identity may have to be saved afterwards.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_name_id_management_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Name Id Management response message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_name_id_management_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Parses the response message and builds the corresponding response object.
     * Performs requested actions against principal federations.  Profile identity
     * may have to be saved afterwards.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_name_id_management_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNameIdManagementNoInit extends LassoNameIdManagement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoEcp extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_ecp_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoEcp  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_assertionConsumerURL() {
        $t = LassoEcp_assertionConsumerURL_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerURL($value) {
        LassoEcp_assertionConsumerURL_set($this->_cptr, $value);
    }

    public function processAuthnRequestMsg($authn_request_msg) {
        $rc = lasso_ecp_process_authn_request_msg($this->_cptr, $authn_request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    public function processResponseMsg($response_msg) {
        $rc = lasso_ecp_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoEcpNoInit extends LassoEcp {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLogin extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_login_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLogin  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_login_new_from_dump($server->_cptr, $dump));
    }

    /**'
    * @return int
    */
    protected function get_protocolProfile() {
        $t = LassoLogin_protocolProfile_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_protocolProfile($value) {
        $value = $value->_cptr;
        LassoLogin_protocolProfile_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionArtifact() {
        $t = LassoLogin_assertionArtifact_get($this->_cptr);
        return $t;
    }
    protected function set_assertionArtifact($value) {
        LassoLogin_assertionArtifact_set($this->_cptr, $value);
    }

    /**
     * @return LassoNode
     */
    protected function get_assertion() {
        $cptr = lasso_login_get_assertion($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * Gets the assertion of the response and adds it to the LassoSession object.
     * Builds a federation with the 2 name identifiers of the assertion
     * and adds it into the identity.
     * If the session or the identity are NULL, they are created.
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem><para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_RESPONSE if no response is present in the login profile object;
     * usually because no call to lasso_login_process_authn_response_msg was done;
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_ASSERTION if the response does not contain an assertion,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND if the assertion does not contain a NameID element,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER same as
     * LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND,
     * </para></listitem>
     * <listitem><para>
     * LASSO_LOGIN_ERROR_ASSERTION_REPLAY if the assertion has already been used.
     * </para></listitem>
     * </itemizedlist>
     */
    public function acceptSso() {
        $rc = lasso_login_accept_sso($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds a SAML artifact. Depending of the HTTP method, the data for the sending of
     * the artifact are stored in $msg_url (REDIRECT) or $msg_url, $msg_body and
     * $msg_relayState (POST).
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem><para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID if no remote provider ID was setup in the login
     * profile object, it's usually done by lasso_login_process_authn_request_msg,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD if the HTTP method is neither LASSO_HTTP_METHOD_REDIRECT
     * or LASSO_HTTP_METHOD_POST (ID-FF 1.2 case) or neither LASSO_HTTP_METHOD_ARTIFACT_GET or
     * LASSO_HTTP_METHOD_ARTIFACT_POST (SAML 2.0 case) for SAML 2.0),
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE if the current protocolProfile is not
     * </para></listitem>
     * <listitem><para>
     * LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_ART (only for ID-FF 1.2),
     * </para></listitem>
     * <listitem><para>
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the remote provider is not known to our server object
     * which impeach us to find a service endpoint,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_RESPONSE if the response object is missing,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_STATUS_CODE if the response object is missing a status code,
     * </para></listitem>
     * /itemizedlist>
     * 
     */
    public function buildArtifactMsg($http_method) {
        $rc = lasso_login_build_artifact_msg($this->_cptr, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds an assertion and stores it in profile session.
     * $authenticationInstant, reauthenticateOnOrAfter, $notBefore and
     * $notOnOrAfter may be NULL.  If $authenticationInstant is NULL, the current
     * time will be used.  Time values must be encoded in UTC.
     * 
     * Construct the authentication assertion for the response. It must be called after validating the
     * request using lasso_login_validate_request_msg(). The created assertion is accessed using
     * lasso_login_get_assertion().
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem><para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND if no identity object was found in the login profile object.
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_RESPONSE if no response object is present ( it is normally initialized
     * by lasso_login_process_authn_request_msg() )
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND if a LASSO_SAML2_NAME_IDENTIFIER_FORMAT_PERSISTENT or LASSO_SAML2_NAME_IDENTIFIER_FORMAT_ENCRYPTED NameID format is asked and no corresponding federation was found in the LassoIdentity object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if encryption is needed and the request issuing provider is unknown (it as not been registered in the LassoServer object),
     * </para></listitem>
     * <listitem><para>
     * LASSO_DS_ERROR_ENCRYPTION_FAILED if encryption is needed but it failed,
     * </para></listitem>
     * </itemizedlist>
     * 
     */
    public function buildAssertion($authenticationMethod = null, $authenticationInstant = null, $reauthenticateOnOrAfter = null, $notBefore = null, $notOnOrAfter = null) {
        $rc = lasso_login_build_assertion($this->_cptr, $authenticationMethod, $authenticationInstant, $reauthenticateOnOrAfter, $notBefore, $notOnOrAfter);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile authentication request ($request member) into a Liberty message, either an URL
     * in HTTP-Redirect profile or an URL and a field value in Browser-POST (form) profile.
     * 
     * The URL is set into the $msg_url member and the eventual field value (LAREQ) is set into the
     * $msg_body member.
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem><para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID if not remote provider ID was setup&160;- it usually
     * means that lasso_login_init_request() was not called before,
     * </para></listitem>
     * <listitem><para>
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the remote provider ID is not registered in the server
     * object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE if the SSO profile is not supported by the targeted
     * provider,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED if the building of the query part of the redirect URL
     * or of the body of the POST content failed&160;- it only happens with the LASSO_HTTP_METHOD_REDIRECT,
     * LASSO_HTTP_METHOD_POST, LASSO_HTTP_METHOD_ARTIFACT_GET and
     * LASSO_HTTP_METHOD_ARTIFACT_POST bindings&160;-,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL if the metadata of the remote provider does not contain
     * an url for the SSO profile,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_INVALID_REQUEST if the request object is not of the needed type, is usually
     * means that lasso_login_init_request() was not called before,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_MISSING_REQUEST if the request object is missing,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD if the current setted $http_method on the LassoLogin
     * object is invalid.
     * </para></listitem>
     * </itemizedlist>
     */
    public function buildAuthnRequestMsg() {
        $rc = lasso_login_build_authn_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile authentication response ($response member) into a Liberty
     * message.
     * 
     * The URL is set into the $msg_url member and the field value (LARES) is set
     * into the $msg_body member.
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem><para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE if the current protocol profile is not
     * </para></listitem>
     * <listitem><para>
     * LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_POST or LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_LECP,
     * </para></listitem>
     * <listitem><para>
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the remote provider ID is not registered in the server
     * object,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL if the metadata of the remote provider does not contain
     * an URL for the assertion consuming service,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_SERVER the server object is needed to sign a message and it is
     * missing,
     * </para></listitem>
     * <listitem><para>
     * LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED the private key for signing could not be found,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_MISSING_RESPONSE if the response object is missing,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE if the SSO profile is not supported by the targeted
     * provider,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_BUILDING_QUERY_FAILED if using LASSO_HTTP_METHOD_REDIRECT building of the redirect
     * URL failed,
     * </para></listitem>
     * <listitem><para>
     * LASSO_PROFILE_BUILDING_MSG_FAILED if using LASSO_HTTP_METHOD_POST, LASSO_HTTP_METHOD_SOAP or
     * LASSO_HTTP_METHOD_PAOS and building the $msg_body failed.
     * </para></listitem>
     * </itemizedlist>
     * 
     */
    public function buildAuthnResponseMsg() {
        $rc = lasso_login_build_authn_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Produce a SOAP Artifact Resolve message. It must follows a call to
     * lasso_login_init_request() on the artifact message.
     * Converts  artifact request into a Liberty SOAP message.
     * 
     * The URL is set into the $msg_url member and the SOAP message is set into the
     * $msg_body member. You should POST the $msg_body to the $msg_url afterward.
     * 
     * @return lasso_error_t 0 on success; or
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID if not remote provider ID was setup -- it usually
     * means that lasso_login_init_request was not called before,
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the remote provider ID is not registered in the server
     * object.
     * 
     */
    public function buildRequestMsg() {
        $rc = lasso_login_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile assertion response ($response member) into a Liberty SOAP
     * messageresponse message.
     * 
     * The URL is set into the $msg_url member and the SOAP message is set into the
     * $msg_body member.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * LASSO_PROFILE_ERROR_SESSION_NOT_FOUND if no session object was found in the login profile object
     * -- it should be created by lasso_login_build_assertion() if you did not set it manually before
     *  calling lasso_login_build_assertion().
     * 
     */
    public function buildResponseMsg($remote_providerID = null) {
        $rc = lasso_login_build_response_msg($this->_cptr, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_login_dump($this->_cptr);
    }

    /**
     * <para>Initializes a new AuthnRequest from current service provider to remote
     * identity provider specified in $remote_providerID (if NULL the first known
     * identity provider is used).</para>
     * 
     * <para>For ID-FF 1.2 the default NameIDPolicy in an AuthnRequest is None, which imply that a
     * federation must already exist on the IdP side.</para>
     * 
     * <para>For SAML 2.0 the default NameIDPolicy is the first listed in the metadatas of the current
     * provider, or if none is specified, Transient, which ask the IdP to give a one-time
     * federation</para>
     * 
     * @return lasso_error_t 0 on success; or <itemizedlist>
     * <listitem><para>LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID if $remote_providerID is NULL and no default remote
     * provider could be found from the server object -- usually the first one in the order of adding to
     * the server object --,</para></listitem>
     * <listitem><para>LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the $remote_providerID is not known to our server object.</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD if the HTTP method is neither LASSO_HTTP_METHOD_REDIRECT
     * or LASSO_HTTP_METHOD_POST,</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED if creation of the request object failed.</para></listitem>
     * </itemizedlist>
     * 
     */
    public function initAuthnRequest($remote_providerID = null, $http_method = LASSO_HTTP_METHOD_REDIRECT) {
        $rc = lasso_login_init_authn_request($this->_cptr, $remote_providerID, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes an artifact request. $response_msg is either the query string
     * (in redirect mode) or the form LAREQ field (in browser-post mode).
     * It should only be used if you received an artifact message, $response_msg must be content of the
     * artifact field for the POST artifact binding of the query string for the REDIRECT artifact
     * binding. You must set the $response_http_method argument according to the way you received the
     * artifact message.
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem>
     * <para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PARAM_ERROR_INVALID_VALUE if $response_msg is NULL,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD if the HTTP method is neither LASSO_HTTP_METHOD_REDIRECT
     * or LASSO_HTTP_METHOD_POST (in the ID-FF 1.2 case) or neither LASSO_HTTP_METHOD_ARTIFACT_GET or
     * LASSO_HTTP_METHOD_ARTIFACT_POST (in the SAML 2.0 case),
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PROFILE_ERROR_MISSING_ARTIFACT if no artifact field was found in the query string (only
     * possible for the LASSO_HTTP_METHOD_REDIRECT case),
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PROFILE_ERROR_INVALID_ARTIFACT if decoding of the artifact failed -- whether because
     * the base64 encoding is invalid or because the type code is wrong --,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID if no provider ID could be found corresponding to
     * the hash contained in the artifact.
     * </para>
     * </listitem>
     * </itemizedlist>
     * 
     */
    public function initRequest($response_msg, $response_http_method = LASSO_HTTP_METHOD_REDIRECT) {
        $rc = lasso_login_init_request($this->_cptr, $response_msg, $response_http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * <para>Generates an authentication response without matching authentication
     * request.</para>
     * 
     * <para>The choice of NameIDFormat is the same as for lasso_login_init_authn_request() but with the
     * target $remote_providerID as the current provider</para>
     * 
     * <para>If $remote_providerID is NULL, the first known provider is used.</para>
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise. Error codes are the same as
     * lasso_login_init_authn_request().
     */
    public function initIdpInitiatedAuthnRequest($remote_providerID) {
        $rc = lasso_login_init_idp_initiated_authn_request($this->_cptr, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Evaluates if consent must be asked to the Principal to federate him.
     * 
     * @return boolean TRUE if consent must be asked
     */
    public function mustAskForConsent() {
        return lasso_login_must_ask_for_consent($this->_cptr);
    }

    /**
     * Evaluates if user must be authenticated.
     * 
     * @return boolean TRUE if user must be authenticated
     */
    public function mustAuthenticate() {
        return lasso_login_must_authenticate($this->_cptr);
    }

    /**
     * Processes received authentication request, checks it is signed correctly,
     * checks if requested protocol profile is supported, etc.
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem>
     * <para>
     * LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is no a LassoLogin object,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PROFILE_ERROR_MISSING_REQUEST if $authn_request_msg is NULL and no request as actually
     * been processed or initialized &151; see lasso_login_init_idp_initiated_authn_request(),
     * 
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_PROFILE_ERROR_INVALID_MSG if the content of $authn_request_msg cannot be parsed to as a
     * valid lib:AuthnRequest messages for any support binding (mainly HTTP-Redirect, HTTP-Post and
     * SOAP),
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_PROFILE_ERROR_MISSING_ISSUER if the parsed samlp2:AuthnRequest does not have a proper Issuer element,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_PROFILE_ERROR_INVALID_REQUEST if the parsed message does not validate as a valid
     * samlp2:AuthnRequest (SAMLv2) i.e. if there is no Issuer, or mutually exclusive attributes are
     * used (ProtocolBinding and AssertionConsumerServiceIndex),
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE if the protocolProfile (ID-FFv1.2) or the
     * protocolBinding (SAMLv2) is unsupported by Lasso,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE if the protocolProfile (ID-FFv1.2) or the protocolBinding
     * (SAMLv2) for the AssertionConsumer is unsupported by this provider implementation as indicated by
     * its metadata file,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_PROFILE_ERROR_UNKNOWN_PROVIDER, or
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the metadata for the issuer of the request are absent
     * from the LassoServer object of this profile,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_DS_ERROR_SIGNATURE_NOT_FOUND if no signature could be found and signature validation is
     * forced &151; by the service provider metadata with the AuthnRequestsSigned attribute
     * (ID-FFv1.2&SAMLv2), the attribute WantAuthnRequestsSigned in the identity provider metadata file
     * (SAMLv2) or as advised by the lasso_profile_set_signature_verify_hint() method),
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * 
     * LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED if the signature validation failed on a present
     * signature,
     * </para>
     * </listitem>
     * <listitem>
     * <para>
     * LASSO_DS_ERROR_INVALID_SIGNATURE if the signature was malformed and a signature was present,
     * </para>
     * </listitem>
     * </itemizedlist>
     * 
     */
    public function processAuthnRequestMsg($authn_request_msg = null) {
        $rc = lasso_login_process_authn_request_msg($this->_cptr, $authn_request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received authentication response.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processAuthnResponseMsg($authn_response_msg) {
        $rc = lasso_login_process_authn_response_msg($this->_cptr, $authn_response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received artifact request.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_login_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received assertion response.
     * 
     * @return lasso_error_t 0 on success; or
     * <itemizedlist>
     * <listitem><para>LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,</para></listitem>
     * <listitem><para>LASSO_PARAM_ERROR_INVALID_VALUE if response_msg is NULL,</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_INVALID_MSG if the message is not a LassoSamlpResponse (ID-FF 1.2) or a LassoSamlp2ResponseMsg (SAML 2.0),</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_RESPONSE_DOES_NOT_MATCH_REQUEST if the response does not refer to the request or if the response refer to an unknown request and <link linkend="strict-checking"><literal>strict-checking</literal></link> is activated ,</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_REQUEST_DENIED the identity provided
     * returned a failure status of "RequestDenied"</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND if creation of a new
     * federation was not allowed and none existed,</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL if authentication failed
     * or/and if the user cancelled the authentication,</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS, if the response status
     * is a failure but we have no more precise error code to report it, you must
     * look at the second level status in the response,</para></listitem>
     * <listitem><para>LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND, if the issuing
     * provider of the assertion is unknown,</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_INVALID_ISSUER the issuer of the
     * assertion received, is not the expected one</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND no statement was fournd, or none statement contains a subject with a name identifier,</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_MISSING_STATUS_CODE if the reponse is
     * missing a <literal>StatusCode</literal> element,</para></listitem>
     * <listitem><para>LASSO_PROFILE_ERROR_MISSING_ASSERTION if the message does
     * not contain any assertion.</para></listitem>
     * </itemizedlist>
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_login_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes a response to the authentication request received.
     * 
     * @return lasso_error_t 0 on success; or <itemizedlist>
     * <listitem><para>LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ if login is not a LassoLogin object,</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_REQUEST_DENIED</para> if $authentication_result if FALSE,</listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_INVALID_SIGNATURE if signature validation of the request
     * failed,</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST if no signature was present on the
     * request,</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND if federation policy is
     * LASSO_LIB_NAMEID_POLICY_TYPE_NONE and no federation was found in the LassoIdentity object
     * (ID-FF 1.2 case)</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY if request policy is not one of
     * LASSO_LIB_NAMEID_POLICY_TYPE_FEDERATED or LASSO_LIB_NAMEID_POLICY_TYPE_ANY (ID-FF 1.2 case) or if no NameID policy was defined or the AllowCreate request flag is FALSE (SAML 2.0 case),</para></listitem>
     * <listitem><para>LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED if $is_consent_obtained is FALSE and
     * conssent was necessary (for example if the request does not communicate that consent was already
     * obtained from the user),</para></listitem>
     * <listitem><para>LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the requesting provider is unknown,</para></listitem>
     * </itemizedlist>
     */
    public function validateRequestMsg($authentication_result, $is_consent_obtained) {
        $rc = lasso_login_validate_request_msg($this->_cptr, $authentication_result, $is_consent_obtained);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    public function processPaosResponseMsg($msg) {
        $rc = lasso_login_process_paos_response_msg($this->_cptr, $msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoLoginNoInit extends LassoLogin {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLogout extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_logout_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLogout  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_logout_new_from_dump($server->_cptr, $dump));
    }

    /**
     * @return string
     */
    protected function get_nextProviderId() {
        return lasso_logout_get_next_providerID($this->_cptr);
    }

    /**
     * Builds the logout request message.
     * 
     * It gets the HTTP method retrieved to send the request and:
     * <itemizedlist>
     * <listitem><para>
     *   if it is a SOAP method, then it builds the logout request SOAP message,
     *   sets the msg_body attribute, gets the single logout service url and sets
     *   $msg_url in the logout object.
     * </para></listitem>
     * <listitem><para>
     *   if it is a HTTP-Redirect method, then it builds the logout request QUERY
     *   message, builds the logout request url, sets $msg_url in the logout
     *   request url, sets $msg_body to NULL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_logout_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the logout response message.
     * 
     * It gets the request message method and:
     * <itemizedlist>
     * <listitem><para>
     *    if it is a SOAP method, then it builds the logout response SOAP message,
     *    sets the msg_body attribute, gets the single logout service return url
     *    and sets $msg_url in the logout object.
     * </para></listitem>
     * <listitem><para>
     *    if it is a HTTP-Redirect method, then it builds the logout response QUERY message,
     *    builds the logout response url, sets $msg_url with the logout response url,
     *    sets $msg_body to NULL
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_logout_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_logout_dump($this->_cptr);
    }

    /**
     * Initializes a new SLO request.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_providerID = null, $request_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_logout_init_request($this->_cptr, $remote_providerID, $request_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a SLO LogoutRequest message.  Rebuilds a request object from the
     * message and optionally verifies its signature.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_logout_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Parses the response message and builds the response object.
     * 
     * Checks the status code value and if it is not success, then if the local
     * provider is a Service Provider and response method is SOAP, then builds a
     * new logout request message for HTTP Redirect / GET method and returns the
     * error code LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE.
     * 
     * If it is a SOAP method or, IDP type and http method is Redirect/GET,
     * then removes assertion.
     * 
     * If local server is an Identity Provider and if there is no more assertion
     * (Identity Provider has logged out every Service Providers), then restores
     * the initial response.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_logout_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Reset the providerID_index attribute (set to 0).
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function resetProviderIdIndex() {
        $rc = lasso_logout_reset_providerID_index($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * <itemizedlist>
     * <listitem><para>
     *   Sets the remote provider id
     * </para></listitem>
     * <listitem><para>
     *   Sets a logout response with status code value to success.
     * </para></listitem>
     * <listitem><para>
     *   Checks current signature status, if verification failed, stop processing
     *   and set the status code value to failure.
     * </para></listitem>
     * <listitem><para>
     *   Verifies federation and authentication.
     * </para></listitem>
     * <listitem><para>
     *   If the request http method is a SOAP method, then verifies every other
     *   Service Providers supports SOAP method : if not, then sets status code
     *   value to UnsupportedProfile and returns a code error with
     *   LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE.
     * </para></listitem>
     * <listitem><para>
     *   Every tests are ok, then removes assertion.
     * </para></listitem>
     * <listitem><para>
     *   If local server is an Identity Provider and if there is more than one
     *   Service Provider (except the initial Service Provider), then saves the
     *   initial request, response and remote provider id.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return lasso_error_t 0 on success; or
     * LASSO_PROFILE_ERROR_MISSING_REQUEST if no request has been found -- usually means that
     * lasso_logout_process_request_msg was not called,
     * LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND if the requesting provider is not known to the server object,
     * LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED if creation of the response object failed,
     * LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND if the request do not contain a NameID element,
     * LASSO_PROFILE_ERROR_SESSION_NOT_FOUND if the logout profile object do not contain a session
     * object,
     * LASSO_PROFILE_ERROR_MISSING_ASSERTION if no assertion from the requesting provider was found,
     * LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND if the logout profile object do not contain an identity
     * object,
     * LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND if no federation for the requesting provider was found,
     * LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE if the requested HTTP method is not supported by all the
     * remote provider of the current session.
     * 
     */
    public function validateRequest() {
        $rc = lasso_logout_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoLogoutNoInit extends LassoLogout {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoNameRegistration extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_name_registration_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNameRegistration  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_name_registration_new_from_dump($server->_cptr, $dump));
    }

    /**'
    * @return LassoSamlNameIdentifier
    */
    protected function get_oldNameIdentifier() {
        $t = LassoNameRegistration_oldNameIdentifier_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_oldNameIdentifier($value) {
        $value = $value->_cptr;
        LassoNameRegistration_oldNameIdentifier_set($this->_cptr, $value);
    }

    /**
     * Builds a register name identifier request message.
     * 
     * It gets the register name identifier protocol profile and:
     * <itemizedlist>
     * <listitem><para>
     *   if it is a SOAP method, then it builds the register name identifier
     *   request SOAP message, optionally signs his node, sets $msg_body,
     *   gets the SoapEndpoint url and sets $msg_url.
     * </para></listitem>
     * <listitem><para>
     *   if it is a HTTP-Redirect method, then it builds the register name
     *   identifier request QUERY message (optionally signs the request message),
     *   builds the request url with register name identifier url with register
     *   name identifier service url, sets $msg_url in the register name
     *   identifier object, sets $msg_body to NULL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_name_registration_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the register name idendifier response message.
     * 
     * It gets the request message method and:
     * <itemizedlist>
     * <listitem><para>
     *    if it is a SOAP method, then it builds the response SOAP message, sets
     *    the msg_body attribute, gets the register name identifier service return
     *    url and sets $msg_url of the object.
     * </para></listitem>
     * <listitem><para>
     *    if it is a HTTP-Redirect method, then it builds the response QUERY
     *    message, builds the response url, sets $msg_url with the response url
     *    and sets the msg_body with NULL
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_name_registration_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_name_registration_dump($this->_cptr);
    }

    /**
     * Initializes a new lib:RegisterNameIdentifierRequest request; it sets
     * $this->nameIdentifier to the new name identifier and
     * $this->oldNameIdentifier to the old one.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_providerID, $http_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_name_registration_init_request($this->_cptr, $remote_providerID, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:RegisterNameIdentifierRequest message.  Rebuilds a request
     * object from the message and optionally verifies its signature.  Sets
     * profile->nameIdentifier to local name identifier.  If it changed (when this
     * is IdP-initiated and there was no previously defined local name identifier)
     * profile->nameIdentifier will be the new one and profile->oldNameIdentiifer
     * the old one.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_name_registration_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:RegisterNameIdentifierResponse message.  Rebuilds a response
     * object from the message and optionally verifies its signature.
     * 
     * If the response depicts Success it will also update Principal federation.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_name_registration_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Checks profile request with regards to message status and principal
     * federations, update them accordingly and prepares a
     * lib:RegisterNameIdentifierResponse accordingly.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_name_registration_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNameRegistrationNoInit extends LassoNameRegistration {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDefederation extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_defederation_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDefederation  failed "); }
    }

    /**
     * Builds the federation termination notification message.
     * 
     * It gets the federation termination notification protocol profile and:
     * <itemizedlist>
     * <listitem><para>
     *   if it is a SOAP method, then it builds the federation termination
     *   notification SOAP message, optionally signs the notification node, sets
     *   $msg_body, gets the SoapEndpoint url and sets $msg_url of the federation
     *   termination object.
     * </para></listitem>
     * <listitem><para>
     *   if it is a HTTP-Redirect method, then it builds the federation termination
     *   notification QUERY message (optionally signs the notification message),
     *   builds the federation termination notification url with federation
     *   termination service url, sets $msg_url in the federation termination
     *   object, sets $msg_body to NULL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildNotificationMsg() {
        $rc = lasso_defederation_build_notification_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Sets a new federation termination notification to the remote provider id
     * with the provider id of the requester (from the server object) and the name
     * identifier of the federated principal.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initNotification($remote_providerID = null, $http_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_defederation_init_notification($this->_cptr, $remote_providerID, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:FederationTerminationNotification message.  Rebuilds a
     * request object from the message and optionally verifies its signature.
     * 
     * Set the msg_nameIdentifier attribute with the NameIdentifier content of the
     * notification object and optionally set the msg_relayState attribute with the
     * RelayState content of the notification object.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processNotificationMsg($notification_msg) {
        $rc = lasso_defederation_process_notification_msg($this->_cptr, $notification_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Checks notification with regards to message status and principal
     * federations; update them accordingly.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function validateNotification() {
        $rc = lasso_defederation_validate_notification($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoDefederationNoInit extends LassoDefederation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoServer extends LassoProvider {
    public $_cptr = null;

    public function __construct($metadata = null, $private_key = null, $private_key_password = null, $certificate = null) {
        $this->_cptr = lasso_server_new($metadata, $private_key, $private_key_password, $certificate);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoServer  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_server_new_from_dump($dump));
    }

    /**'
    * @return array
    */
    protected function get_providers() {
        $t = LassoServer_providers_get($this->_cptr);
        foreach ($t as $key => $item) {
            $t[$key] = cptrToPhp($item);
        }
        return $t;
    }
    protected function set_providers($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        $value = $array;
        LassoServer_providers_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_privateKey() {
        $t = LassoServer_privateKey_get($this->_cptr);
        return $t;
    }
    protected function set_privateKey($value) {
        LassoServer_privateKey_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_privateKeyPassword() {
        $t = LassoServer_privateKeyPassword_get($this->_cptr);
        return $t;
    }
    protected function set_privateKeyPassword($value) {
        LassoServer_privateKeyPassword_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_certificate() {
        $t = LassoServer_certificate_get($this->_cptr);
        return $t;
    }
    protected function set_certificate($value) {
        LassoServer_certificate_set($this->_cptr, $value);
    }

    /**'
    * @return int
    */
    protected function get_signatureMethod() {
        $t = LassoServer_signatureMethod_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_signatureMethod($value) {
        $value = $value->_cptr;
        LassoServer_signatureMethod_set($this->_cptr, $value);
    }

    /**
     * Configure signature on a saml2:Assertion element.
     * 
     * @return lasso_error_t 0 if successfull, an error code otherwise.
     */
    public function saml2AssertionSetupSignature($saml2_assertion) {
        $rc = lasso_server_saml2_assertion_setup_signature($this->_cptr, $saml2_assertion._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Creates a new LassoProvider and makes it known to the $this
     * 
     * @return lasso_error_t 0 on success; a negative value if an error occured.
     */
    public function addProvider($role, $metadata, $public_key = null, $ca_cert_chain = null) {
        $rc = lasso_server_add_provider($this->_cptr, $role, $metadata, $public_key, $ca_cert_chain);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Creates a new LassoProvider and makes it known to the $this
     * 
     * @return lasso_error_t 0 on success; a negative value if an error occured.
     */
    public function addProviderFromBuffer($role, $metadata, $public_key = null, $ca_cert_chain = null) {
        $rc = lasso_server_add_provider_from_buffer($this->_cptr, $role, $metadata, $public_key, $ca_cert_chain);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * Return value:(transfer full): the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_server_dump($this->_cptr);
    }

    /**
     * Looks up for a LassoProvider whose ID is $providerID and returns it.
     * 
     * @return LassoProvider (transfer none): the LassoProvider, NULL if it was not found.  The
     *     LassoProvider is owned by Lasso and should not be freed.
     */
    public function getProvider($providerID) {
        return lasso_server_get_provider($this->_cptr, $providerID);
    }

    /**
     * Load an encryption private key from a file and set it in the server object
     * 
     * If $filename_or_buffer is NULL, it frees the currently setted key.
     * 
     * @return lasso_error_t 0 on success; another value if an error occured.
     * Deprecated: 2.3: Use lasso_server_set_encryption_private_key_with_password() instead.
     */
    public function setEncryptionPrivateKey($filename_or_buffer = null) {
        $rc = lasso_server_set_encryption_private_key($this->_cptr, $filename_or_buffer);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Load an affiliation metadata file into $this; this must be called after
     * providers have been added to $this.
     * 
     * @return lasso_error_t 0 on success; another value if an error occured.
     */
    public function loadAffiliation($filename) {
        $rc = lasso_server_load_affiliation($this->_cptr, $filename);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Load an encryption private key from a file and set it in the server object. If $password is
     * non-NULL try to decrypt the key with it.
     * 
     * If $filename_or_buffer is NULL, it frees the currently setted key.
     * 
     * @return lasso_error_t 0 on success; another value if an error occured.
     * Since: 2.3
     */
    public function setEncryptionPrivateKeyWithPassword($filename_or_buffer = null, $password = null) {
        $rc = lasso_server_set_encryption_private_key_with_password($this->_cptr, $filename_or_buffer, $password);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoServerNoInit extends LassoServer {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoNameIdentifierMapping extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_name_identifier_mapping_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNameIdentifierMapping  failed "); }
    }

    /**'
    * @return string
    */
    protected function get_targetNameIdentifier() {
        $t = LassoNameIdentifierMapping_targetNameIdentifier_get($this->_cptr);
        return $t;
    }
    protected function set_targetNameIdentifier($value) {
        LassoNameIdentifierMapping_targetNameIdentifier_set($this->_cptr, $value);
    }

    /**
     * Builds a name identifier mapping request message.
     * 
     * <itemizedlist>
     * <listitem><para>
     *   If it is a SOAP method, then it builds the request as a SOAP message,
     *   optionally signs his node, sets $msg_body with that message and sets
     *   $msg_url with the SOAP Endpoint URL
     * </para></listitem>
     * <listitem><para>
     *   If it is a HTTP-Redirect method, then it builds the request as a query
     *   string message, optionally signs it and sets $msg_url to that URL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_name_identifier_mapping_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds a name identifier mapping response message.
     * 
     * <itemizedlist>
     * <listitem><para>
     *   If it is a SOAP method, then it builds the response as a SOAP message,
     *   optionally signs his node, sets $msg_body with that message and sets
     *   $msg_url with the register name identifier service return URL.
     * </para></listitem>
     * <listitem><para>
     *   If it is a HTTP-Redirect method, then it builds the response as a query
     *   string message, optionally signs it and sets $msg_url to that URL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_name_identifier_mapping_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes a new lib:NameIdentifierMappingRequest request.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initRequest($targetNamespace, $remote_providerID = null) {
        $rc = lasso_name_identifier_mapping_init_request($this->_cptr, $targetNamespace, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:NameIdentifierMappingRequest message.  Rebuilds a request
     * object from the message and optionally verifies its signature.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_name_identifier_mapping_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:NameIdentifierMappingResponse message.  Rebuilds a response
     * object from the message and optionally verifies its signature.
     * 
     * If the response depicts Success it will also sets $targetNameIdentifier.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_name_identifier_mapping_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Checks profile request with regards to message status and principal
     * federations, update them accordingly and prepares a
     * lib:NameIdentifierMappingResponse accordingly.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_name_identifier_mapping_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNameIdentifierMappingNoInit extends LassoNameIdentifierMapping {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLecp extends LassoLogin {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_lecp_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLecp  failed "); }
    }

    /**'
    * @return LassoLibAuthnRequestEnvelope
    */
    protected function get_authnRequestEnvelope() {
        $t = LassoLecp_authnRequestEnvelope_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authnRequestEnvelope($value) {
        $value = $value->_cptr;
        LassoLecp_authnRequestEnvelope_set($this->_cptr, $value);
    }

    /**'
    * @return LassoLibAuthnResponseEnvelope
    */
    protected function get_authnResponseEnvelope() {
        $t = LassoLecp_authnResponseEnvelope_get($this->_cptr);
        $t = cptrToPhp($t);
        return $t;
    }
    protected function set_authnResponseEnvelope($value) {
        $value = $value->_cptr;
        LassoLecp_authnResponseEnvelope_set($this->_cptr, $value);
    }

    /**'
    * @return string
    */
    protected function get_assertionConsumerServiceURL() {
        $t = LassoLecp_assertionConsumerServiceURL_get($this->_cptr);
        return $t;
    }
    protected function set_assertionConsumerServiceURL($value) {
        LassoLecp_assertionConsumerServiceURL_set($this->_cptr, $value);
    }

    /**
     * Builds an enveloped authentication request message.  Sets $msg_body to that
     * message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildAuthnRequestEnvelopeMsg() {
        $rc = lasso_lecp_build_authn_request_envelope_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds an authentication request. The data for the sending of the request are
     * stored in $msg_url and $msg_body (SOAP POST).
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildAuthnRequestMsg() {
        $rc = lasso_lecp_build_authn_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the lecp authentication response message (base64).  Sets $msg_body to
     * that message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildAuthnResponseMsg() {
        $rc = lasso_lecp_build_authn_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the enveloped LECP authentication response message (SOAP message).
     * Sets $msg_body to that message.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function buildAuthnResponseEnvelopeMsg() {
        $rc = lasso_lecp_build_authn_response_envelope_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes a new lib:AuthnRequest.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function initAuthnRequest($remote_providerID = null) {
        $rc = lasso_lecp_init_authn_request($this->_cptr, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received authentication request, checks it is signed correctly,
     * checks if requested protocol profile is supported, etc.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processAuthnRequestMsg($authn_request_msg) {
        $rc = lasso_lecp_process_authn_request_msg($this->_cptr, $authn_request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received enveloped authentication request, extracts the
     * authentication request out of it.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processAuthnRequestEnvelopeMsg($request_msg) {
        $rc = lasso_lecp_process_authn_request_envelope_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received enveloped authentication response, extracts the
     * authentication response out of it and stores it in $response.
     * 
     * @return lasso_error_t 0 on success; or a negative value otherwise.
     */
    public function processAuthnResponseEnvelopeMsg($response_msg) {
        $rc = lasso_lecp_process_authn_response_envelope_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoLecpNoInit extends LassoLecp {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoProfileError extends LassoError {}

/**
 * @package Lasso
 */
class LassoProviderError extends LassoError {}

/**
 * @package Lasso
 */
class LassoServerError extends LassoProviderError {}

/**
 * @package Lasso
 */
class LassoLoginError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoLogoutError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoDefederationError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoNameIdentifierMappingError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoWsfProfileError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoDiscoveryError extends LassoWsfProfileError {}

/**
 * @package Lasso
 */
class LassoDataServiceError extends LassoWsfProfileError {}

/**
 * @package Lasso
 */
class LassoDstError extends LassoWsfProfileError {}

/**
 * @package Lasso
 */
class LassoXmlError extends LassoError {}

/**
 * @package Lasso
 */
class LassoXmlNodeNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_NODE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlNodeContentNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_NODE_CONTENT_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlAttrNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_ATTR_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlAttrValueNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_ATTR_VALUE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlInvalidFileError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_INVALID_FILE;
}

/**
 * @package Lasso
 */
class LassoXmlObjectConstructionFailedError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_OBJECT_CONSTRUCTION_FAILED;
}

/**
 * @package Lasso
 */
class LassoXmlMissingNamespaceError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_MISSING_NAMESPACE;
}

/**
 * @package Lasso
 */
class LassoXmlSchemaInvalidFragmentError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_SCHEMA_INVALID_FRAGMENT;
}

/**
 * @package Lasso
 */
class LassoDsError extends LassoError {}

/**
 * @package Lasso
 */
class LassoDsSignatureNotFoundError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoDsInvalidSignatureError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_INVALID_SIGNATURE;
}

/**
 * @package Lasso
 */
class LassoDsSignatureTmplCreationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsContextCreationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_CONTEXT_CREATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsPublicKeyLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_PUBLIC_KEY_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsPrivateKeyLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsCertificateLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_CERTIFICATE_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsSignatureFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsKeysMngrCreationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_KEYS_MNGR_CREATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsKeysMngrInitFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_KEYS_MNGR_INIT_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsSignatureVerificationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsCaCertChainLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsInvalidSigalgError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_INVALID_SIGALG;
}

/**
 * @package Lasso
 */
class LassoDsDigestComputeFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_DIGEST_COMPUTE_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsSignatureTemplateNotFoundError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoDsTooMuchReferencesError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_TOO_MUCH_REFERENCES;
}

/**
 * @package Lasso
 */
class LassoDsInvalidReferenceForSamlError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_INVALID_REFERENCE_FOR_SAML;
}

/**
 * @package Lasso
 */
class LassoDsDecryptionFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_DECRYPTION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsEncryptionFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_ENCRYPTION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsDecryptionFailedMissingPrivateKeyError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_DECRYPTION_FAILED_MISSING_PRIVATE_KEY;
}

/**
 * @package Lasso
 */
class LassoServerProviderNotFoundError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoServerAddProviderFailedError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_ADD_PROVIDER_FAILED;
}

/**
 * @package Lasso
 */
class LassoServerAddProviderProtocolMismatchError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH;
}

/**
 * @package Lasso
 */
class LassoServerSetEncryptionPrivateKeyFailedError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED;
}

/**
 * @package Lasso
 */
class LassoServerInvalidXmlError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_INVALID_XML;
}

/**
 * @package Lasso
 */
class LassoLogoutUnsupportedProfileError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE;
}

/**
 * @package Lasso
 */
class LassoLogoutRequestDeniedError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_REQUEST_DENIED;
}

/**
 * @package Lasso
 */
class LassoLogoutFederationNotFoundError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_FEDERATION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoLogoutUnknownPrincipalError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_UNKNOWN_PRINCIPAL;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidQueryError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_QUERY;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidPostMsgError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_POST_MSG;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidSoapMsgError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_SOAP_MSG;
}

/**
 * @package Lasso
 */
class LassoProfileMissingRequestError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_REQUEST;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidHttpMethodError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidProtocolprofileError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidMsgError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_MSG;
}

/**
 * @package Lasso
 */
class LassoProfileMissingRemoteProvideridError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID;
}

/**
 * @package Lasso
 */
class LassoProfileUnsupportedProfileError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE;
}

/**
 * @package Lasso
 */
class LassoProfileUnknownProfileUrlError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL;
}

/**
 * @package Lasso
 */
class LassoProfileIdentityNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileFederationNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileNameIdentifierNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingQueryFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingRequestFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingMessageFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_MESSAGE_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingResponseFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileSessionNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_SESSION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileBadIdentityDumpError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BAD_IDENTITY_DUMP;
}

/**
 * @package Lasso
 */
class LassoProfileBadSessionDumpError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BAD_SESSION_DUMP;
}

/**
 * @package Lasso
 */
class LassoProfileMissingResponseError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_RESPONSE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingStatusCodeError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_STATUS_CODE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingArtifactError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ARTIFACT;
}

/**
 * @package Lasso
 */
class LassoProfileMissingResourceOfferingError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_RESOURCE_OFFERING;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServiceDescriptionError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServiceTypeError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVICE_TYPE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingAssertionError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ASSERTION;
}

/**
 * @package Lasso
 */
class LassoProfileMissingSubjectError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SUBJECT;
}

/**
 * @package Lasso
 */
class LassoProfileMissingNameIdentifierError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidArtifactError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_ARTIFACT;
}

/**
 * @package Lasso
 */
class LassoProfileMissingEncryptionPrivateKeyError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY;
}

/**
 * @package Lasso
 */
class LassoProfileStatusNotSuccessError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_STATUS_NOT_SUCCESS;
}

/**
 * @package Lasso
 */
class LassoProfileMissingIssuerError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ISSUER;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServiceInstanceError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVICE_INSTANCE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingEndpointReferenceError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingEndpointReferenceAddressError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidIssuerError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_ISSUER;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServerError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVER;
}

/**
 * @package Lasso
 */
class LassoProfileUnknownProviderError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNKNOWN_PROVIDER;
}

/**
 * @package Lasso
 */
class LassoProfileCannotVerifySignatureError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_CANNOT_VERIFY_SIGNATURE;
}

/**
 * @package Lasso
 */
class LassoProfileCannotFindAProviderError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_CANNOT_FIND_A_PROVIDER;
}

/**
 * @package Lasso
 */
class LassoProfileResponseDoesNotMatchRequestError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_RESPONSE_DOES_NOT_MATCH_REQUEST;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidRequestError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_REQUEST;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidResponseError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_RESPONSE;
}

/**
 * @package Lasso
 */
class LassoProfileUnsupportedBindingError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNSUPPORTED_BINDING;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidAssertionConditionsError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_ASSERTION_CONDITIONS;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidAssertionError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_ASSERTION;
}

/**
 * @package Lasso
 */
class LassoProfileUnknownIssuerError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNKNOWN_ISSUER;
}

/**
 * @package Lasso
 */
class LassoProfileIssuerIsNotAnIdpError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_ISSUER_IS_NOT_AN_IDP;
}

/**
 * @package Lasso
 */
class LassoParamError extends LassoError {}

/**
 * @package Lasso
 */
class LassoParamBadTypeOrNullObjError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ;
}

/**
 * @package Lasso
 */
class LassoParamInvalidValueError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_INVALID_VALUE;
}

/**
 * @package Lasso
 */
class LassoParamCheckFailedError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_CHECK_FAILED;
}

/**
 * @package Lasso
 */
class LassoParamNonInitializedObjectError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_NON_INITIALIZED_OBJECT;
}

/**
 * @package Lasso
 */
class LassoLoginFederationNotFoundError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoLoginConsentNotObtainedError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED;
}

/**
 * @package Lasso
 */
class LassoLoginInvalidNameidpolicyError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY;
}

/**
 * @package Lasso
 */
class LassoLoginRequestDeniedError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_REQUEST_DENIED;
}

/**
 * @package Lasso
 */
class LassoLoginInvalidSignatureError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_INVALID_SIGNATURE;
}

/**
 * @package Lasso
 */
class LassoLoginUnsignedAuthnRequestError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST;
}

/**
 * @package Lasso
 */
class LassoLoginStatusNotSuccessError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS;
}

/**
 * @package Lasso
 */
class LassoLoginUnknownPrincipalError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL;
}

/**
 * @package Lasso
 */
class LassoLoginNoDefaultEndpointError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_NO_DEFAULT_ENDPOINT;
}

/**
 * @package Lasso
 */
class LassoLoginAssertionReplayError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_ASSERTION_REPLAY;
}

/**
 * @package Lasso
 */
class LassoLoginAssertionDoesNotMatchRequestIdError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_ASSERTION_DOES_NOT_MATCH_REQUEST_ID;
}

/**
 * @package Lasso
 */
class LassoLoginInvalidAssertionSignatureError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_INVALID_ASSERTION_SIGNATURE;
}

/**
 * @package Lasso
 */
class LassoDefederationMissingNameIdentifierError extends LassoDefederationError {
    protected $code = LASSO_DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER;
}

/**
 * @package Lasso
 */
class LassoSoapError extends LassoError {}

/**
 * @package Lasso
 */
class LassoSoapRedirectRequestFaultError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_REDIRECT_REQUEST_FAULT;
}

/**
 * @package Lasso
 */
class LassoSoapMissingEnvelopeError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_ENVELOPE;
}

/**
 * @package Lasso
 */
class LassoSoapMissingHeaderError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_HEADER;
}

/**
 * @package Lasso
 */
class LassoSoapMissingBodyError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_BODY;
}

/**
 * @package Lasso
 */
class LassoSoapMissingSoapFaultDetailError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL;
}

/**
 * @package Lasso
 */
class LassoNameidentifiermappingMissingTargetNamespaceError extends LassoNameIdentifierMappingError {
    protected $code = LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE;
}

/**
 * @package Lasso
 */
class LassoNameidentifiermappingForbiddenCallOnThisSideError extends LassoNameIdentifierMappingError {
    protected $code = LASSO_NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE;
}

/**
 * @package Lasso
 */
class LassoNameidentifiermappingMissingTargetIdentifierError extends LassoNameIdentifierMappingError {
    protected $code = LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER;
}

/**
 * @package Lasso
 */
class LassoDataserviceUnregisteredDstError extends LassoDataServiceError {
    protected $code = LASSO_DATA_SERVICE_ERROR_UNREGISTERED_DST;
}

/**
 * @package Lasso
 */
class LassoDataserviceCannotAddItemError extends LassoDataServiceError {
    protected $code = LASSO_DATA_SERVICE_ERROR_CANNOT_ADD_ITEM;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingCorrelationError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_CORRELATION;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingSecurityError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_SECURITY;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingAssertionIdError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_ASSERTION_ID;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingEndpointError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_ENDPOINT;
}

/**
 * @package Lasso
 */
class LassoWsfprofileSoapFaultError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_SOAP_FAULT;
}

/**
 * @package Lasso
 */
class LassoWsfprofileUnsupportedSecurityMechanismError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingDescriptionError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_DESCRIPTION;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingResourceIdError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_RESOURCE_ID;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingCredentialRefError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_CREDENTIAL_REF;
}

/**
 * @package Lasso
 */
class LassoWsfprofileInvalidOrMissingReferenceToMessageIdError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_INVALID_OR_MISSING_REFERENCE_TO_MESSAGE_ID;
}

/**
 * @package Lasso
 */
class LassoWsfprofileSecurityMechanismCheckFailedError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_SECURITY_MECHANISM_CHECK_FAILED;
}

/**
 * @package Lasso
 */
class LassoWsfprofileUnknownStatusCodeError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_UNKNOWN_STATUS_CODE;
}

/**
 * @package Lasso
 */
class LassoWsfprofileServerInteractionRequiredError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED;
}

/**
 * @package Lasso
 */
class LassoWsfprofileServerInteractionRequiredForDataError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED_FOR_DATA;
}

/**
 * @package Lasso
 */
class LassoWsfprofileRedirectRequestError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST;
}

/**
 * @package Lasso
 */
class LassoWsfprofileRedirectRequestUnsupportedByRequesterError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST_UNSUPPORTED_BY_REQUESTER;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingSenderIdError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_SENDER_ID;
}

/**
 * @package Lasso
 */
class LassoDiscoverySvcMetadataRegisterFailedError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED;
}

/**
 * @package Lasso
 */
class LassoDiscoverySvcMetadataAssociationAddFailedError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDiscoveryMissingRequestedServiceError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE;
}

/**
 * @package Lasso
 */
class LassoDiscoveryFailedToBuildEndpointReferenceError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE;
}

/**
 * @package Lasso
 */
class LassoDstMissingServiceDataError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MISSING_SERVICE_DATA;
}

/**
 * @package Lasso
 */
class LassoDstQueryFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_QUERY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstQueryPartiallyFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_QUERY_PARTIALLY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstModifyFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MODIFY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstModifyPartiallyFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MODIFY_PARTIALLY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstNewDataMissingError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_NEW_DATA_MISSING;
}

/**
 * @package Lasso
 */
class LassoDstQueryNotFoundError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_QUERY_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoDstNoDataError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_NO_DATA;
}

/**
 * @package Lasso
 */
class LassoDstMalformedQueryError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MALFORMED_QUERY;
}

/**
 * @package Lasso
 */
class LassoDstEmptyRequestError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_EMPTY_REQUEST;
}

/**
 * @package Lasso
 */
class LassoRegistryError extends LassoError {}

/**
 * @package Lasso
 */
class LassoRegistryKeyExistsError extends LassoRegistryError {
    protected $code = LASSO_REGISTRY_ERROR_KEY_EXISTS;
}

/**
 * @package Lasso
 */
class LassoProviderMissingPublicKeyError extends LassoProviderError {
    protected $code = LASSO_PROVIDER_ERROR_MISSING_PUBLIC_KEY;
}

/**
 * @package Lasso
 */
class LassoWssecError extends LassoError {}

/**
 * @package Lasso
 */
class LassoWssecMissingSecurityTokenError extends LassoWssecError {
    protected $code = LASSO_WSSEC_ERROR_MISSING_SECURITY_TOKEN;
}

/**
 * @package Lasso
 */
class LassoWssecBadPasswordError extends LassoWssecError {
    protected $code = LASSO_WSSEC_ERROR_BAD_PASSWORD;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryError extends LassoError {}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryFailedError extends LassoIdwsf2DiscoveryError {
    protected $code = LASSO_IDWSF2_DISCOVERY_ERROR_FAILED;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryForbiddenError extends LassoIdwsf2DiscoveryError {
    protected $code = LASSO_IDWSF2_DISCOVERY_ERROR_FORBIDDEN;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryDuplicateError extends LassoIdwsf2DiscoveryError {
    protected $code = LASSO_IDWSF2_DISCOVERY_ERROR_DUPLICATE;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryLogicalDuplicateError extends LassoIdwsf2DiscoveryError {
    protected $code = LASSO_IDWSF2_DISCOVERY_ERROR_LOGICAL_DUPLICATE;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryNoResultsError extends LassoIdwsf2DiscoveryError {
    protected $code = LASSO_IDWSF2_DISCOVERY_ERROR_NO_RESULTS;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DiscoveryNotFoundError extends LassoIdwsf2DiscoveryError {
    protected $code = LASSO_IDWSF2_DISCOVERY_ERROR_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DstError extends LassoError {}

/**
 * @package Lasso
 */
class LassoIdwsf2DstDuplicateItemError extends LassoIdwsf2DstError {
    protected $code = LASSO_IDWSF2_DST_ERROR_DUPLICATE_ITEM;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DstPartialFailureError extends LassoIdwsf2DstError {
    protected $code = LASSO_IDWSF2_DST_ERROR_PARTIAL_FAILURE;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DstUnknownStatusCodeError extends LassoIdwsf2DstError {
    protected $code = LASSO_IDWSF2_DST_ERROR_UNKNOWN_STATUS_CODE;
}

/**
 * @package Lasso
 */
class LassoIdwsf2DstItemNotFoundError extends LassoIdwsf2DstError {
    protected $code = LASSO_IDWSF2_DST_ERROR_ITEM_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoAssertionQueryError extends LassoError {}

/**
 * @package Lasso
 */
class LassoAssertionqueryAttributeRequestAlreadyExistError extends LassoAssertionQueryError {
    protected $code = LASSO_ASSERTION_QUERY_ERROR_ATTRIBUTE_REQUEST_ALREADY_EXIST;
}

/**
 * @package Lasso
 */
class LassoAssertionqueryNotAnAttributeQueryError extends LassoAssertionQueryError {
    protected $code = LASSO_ASSERTION_QUERY_ERROR_NOT_AN_ATTRIBUTE_QUERY;
}

/**
 * @package Lasso
 */
class LassoError extends Exception {
    private static $exceptions_dict = array(
        LASSO_WSF_PROFILE_ERROR_UNKNOWN_STATUS_CODE => "LassoWsfprofileUnknownStatusCodeError",
        LASSO_PROFILE_ERROR_SESSION_NOT_FOUND => "LassoProfileSessionNotFoundError",
        LASSO_WSF_PROFILE_ERROR_MISSING_ENDPOINT => "LassoWsfprofileMissingEndpointError",
        LASSO_LOGIN_ERROR_ASSERTION_REPLAY => "LassoLoginAssertionReplayError",
        LASSO_DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED => "LassoDiscoverySvcMetadataRegisterFailedError",
        LASSO_DS_ERROR_DIGEST_COMPUTE_FAILED => "LassoDsDigestComputeFailedError",
        LASSO_LOGIN_ERROR_ASSERTION_DOES_NOT_MATCH_REQUEST_ID => "LassoLoginAssertionDoesNotMatchRequestIdError",
        LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE => "LassoNameidentifiermappingMissingTargetNamespaceError",
        LASSO_DS_ERROR_SIGNATURE_NOT_FOUND => "LassoDsSignatureNotFoundError",
        LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND => "LassoLoginFederationNotFoundError",
        LASSO_PROFILE_ERROR_INVALID_RESPONSE => "LassoProfileInvalidResponseError",
        LASSO_DS_ERROR_DECRYPTION_FAILED => "LassoDsDecryptionFailedError",
        LASSO_DS_ERROR_SIGNATURE_FAILED => "LassoDsSignatureFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVER => "LassoProfileMissingServerError",
        LASSO_DS_ERROR_CERTIFICATE_LOAD_FAILED => "LassoDsCertificateLoadFailedError",
        LASSO_WSF_PROFILE_ERROR_MISSING_SENDER_ID => "LassoWsfprofileMissingSenderIdError",
        LASSO_WSF_PROFILE_ERROR_INVALID_OR_MISSING_REFERENCE_TO_MESSAGE_ID => "LassoWsfprofileInvalidOrMissingReferenceToMessageIdError",
        LASSO_DST_ERROR_MODIFY_FAILED => "LassoDstModifyFailedError",
        LASSO_DS_ERROR_INVALID_SIGALG => "LassoDsInvalidSigalgError",
        LASSO_IDWSF2_DISCOVERY_ERROR_FORBIDDEN => "LassoIdwsf2DiscoveryForbiddenError",
        LASSO_DS_ERROR_KEYS_MNGR_INIT_FAILED => "LassoDsKeysMngrInitFailedError",
        LASSO_DST_ERROR_MISSING_SERVICE_DATA => "LassoDstMissingServiceDataError",
        LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE => "LassoLogoutUnsupportedProfileError",
        LASSO_IDWSF2_DISCOVERY_ERROR_DUPLICATE => "LassoIdwsf2DiscoveryDuplicateError",
        LASSO_DS_ERROR_TOO_MUCH_REFERENCES => "LassoDsTooMuchReferencesError",
        LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED => "LassoProfileBuildingQueryFailedError",
        LASSO_DST_ERROR_QUERY_PARTIALLY_FAILED => "LassoDstQueryPartiallyFailedError",
        LASSO_LOGOUT_ERROR_UNKNOWN_PRINCIPAL => "LassoLogoutUnknownPrincipalError",
        LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE => "LassoProfileInvalidProtocolprofileError",
        LASSO_SOAP_ERROR_REDIRECT_REQUEST_FAULT => "LassoSoapRedirectRequestFaultError",
        LASSO_DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND => "LassoDsSignatureTemplateNotFoundError",
        LASSO_PROFILE_ERROR_ISSUER_IS_NOT_AN_IDP => "LassoProfileIssuerIsNotAnIdpError",
        LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY => "LassoLoginInvalidNameidpolicyError",
        LASSO_DS_ERROR_ENCRYPTION_FAILED => "LassoDsEncryptionFailedError",
        LASSO_DS_ERROR_INVALID_SIGNATURE => "LassoDsInvalidSignatureError",
        LASSO_PROFILE_ERROR_STATUS_NOT_SUCCESS => "LassoProfileStatusNotSuccessError",
        LASSO_IDWSF2_DISCOVERY_ERROR_FAILED => "LassoIdwsf2DiscoveryFailedError",
        LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS => "LassoLoginStatusNotSuccessError",
        LASSO_PROFILE_ERROR_RESPONSE_DOES_NOT_MATCH_REQUEST => "LassoProfileResponseDoesNotMatchRequestError",
        LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND => "LassoProfileFederationNotFoundError",
        LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND => "LassoServerProviderNotFoundError",
        LASSO_DST_ERROR_MODIFY_PARTIALLY_FAILED => "LassoDstModifyPartiallyFailedError",
        LASSO_SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL => "LassoSoapMissingSoapFaultDetailError",
        LASSO_WSSEC_ERROR_MISSING_SECURITY_TOKEN => "LassoWssecMissingSecurityTokenError",
        LASSO_XML_ERROR_ATTR_NOT_FOUND => "LassoXmlAttrNotFoundError",
        LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ => "LassoParamBadTypeOrNullObjError",
        LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED => "LassoWsfprofileServerInteractionRequiredError",
        LASSO_WSF_PROFILE_ERROR_MISSING_CREDENTIAL_REF => "LassoWsfprofileMissingCredentialRefError",
        LASSO_DS_ERROR_INVALID_REFERENCE_FOR_SAML => "LassoDsInvalidReferenceForSamlError",
        LASSO_XML_ERROR_SCHEMA_INVALID_FRAGMENT => "LassoXmlSchemaInvalidFragmentError",
        LASSO_DST_ERROR_NO_DATA => "LassoDstNoDataError",
        LASSO_DS_ERROR_KEYS_MNGR_CREATION_FAILED => "LassoDsKeysMngrCreationFailedError",
        LASSO_DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED => "LassoDsCaCertChainLoadFailedError",
        LASSO_WSF_PROFILE_ERROR_SOAP_FAULT => "LassoWsfprofileSoapFaultError",
        LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED => "LassoProfileBuildingRequestFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVICE_TYPE => "LassoProfileMissingServiceTypeError",
        LASSO_DST_ERROR_NEW_DATA_MISSING => "LassoDstNewDataMissingError",
        LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED => "LassoDsPrivateKeyLoadFailedError",
        LASSO_IDWSF2_DISCOVERY_ERROR_LOGICAL_DUPLICATE => "LassoIdwsf2DiscoveryLogicalDuplicateError",
        LASSO_WSF_PROFILE_ERROR_MISSING_RESOURCE_ID => "LassoWsfprofileMissingResourceIdError",
        LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED_FOR_DATA => "LassoWsfprofileServerInteractionRequiredForDataError",
        LASSO_NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE => "LassoNameidentifiermappingForbiddenCallOnThisSideError",
        LASSO_XML_ERROR_ATTR_VALUE_NOT_FOUND => "LassoXmlAttrValueNotFoundError",
        LASSO_PROFILE_ERROR_INVALID_SOAP_MSG => "LassoProfileInvalidSoapMsgError",
        LASSO_PROFILE_ERROR_MISSING_SUBJECT => "LassoProfileMissingSubjectError",
        LASSO_REGISTRY_ERROR_KEY_EXISTS => "LassoRegistryKeyExistsError",
        LASSO_XML_ERROR_NODE_NOT_FOUND => "LassoXmlNodeNotFoundError",
        LASSO_WSF_PROFILE_ERROR_MISSING_DESCRIPTION => "LassoWsfprofileMissingDescriptionError",
        LASSO_PROFILE_ERROR_INVALID_REQUEST => "LassoProfileInvalidRequestError",
        LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND => "LassoProfileNameIdentifierNotFoundError",
        LASSO_PROFILE_ERROR_CANNOT_VERIFY_SIGNATURE => "LassoProfileCannotVerifySignatureError",
        LASSO_WSF_PROFILE_ERROR_MISSING_SECURITY => "LassoWsfprofileMissingSecurityError",
        LASSO_LOGOUT_ERROR_FEDERATION_NOT_FOUND => "LassoLogoutFederationNotFoundError",
        LASSO_XML_ERROR_OBJECT_CONSTRUCTION_FAILED => "LassoXmlObjectConstructionFailedError",
        LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE => "LassoProfileMissingEndpointReferenceError",
        LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER => "LassoNameidentifiermappingMissingTargetIdentifierError",
        LASSO_PROFILE_ERROR_INVALID_ISSUER => "LassoProfileInvalidIssuerError",
        LASSO_PROFILE_ERROR_INVALID_POST_MSG => "LassoProfileInvalidPostMsgError",
        LASSO_PROFILE_ERROR_UNSUPPORTED_BINDING => "LassoProfileUnsupportedBindingError",
        LASSO_IDWSF2_DST_ERROR_UNKNOWN_STATUS_CODE => "LassoIdwsf2DstUnknownStatusCodeError",
        LASSO_DST_ERROR_EMPTY_REQUEST => "LassoDstEmptyRequestError",
        LASSO_PROFILE_ERROR_BUILDING_MESSAGE_FAILED => "LassoProfileBuildingMessageFailedError",
        LASSO_XML_ERROR_INVALID_FILE => "LassoXmlInvalidFileError",
        LASSO_PROFILE_ERROR_MISSING_RESOURCE_OFFERING => "LassoProfileMissingResourceOfferingError",
        LASSO_PROFILE_ERROR_UNKNOWN_PROVIDER => "LassoProfileUnknownProviderError",
        LASSO_PARAM_ERROR_CHECK_FAILED => "LassoParamCheckFailedError",
        LASSO_WSF_PROFILE_ERROR_MISSING_ASSERTION_ID => "LassoWsfprofileMissingAssertionIdError",
        LASSO_LOGIN_ERROR_REQUEST_DENIED => "LassoLoginRequestDeniedError",
        LASSO_PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY => "LassoProfileMissingEncryptionPrivateKeyError",
        LASSO_WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM => "LassoWsfprofileUnsupportedSecurityMechanismError",
        LASSO_WSF_PROFILE_ERROR_SECURITY_MECHANISM_CHECK_FAILED => "LassoWsfprofileSecurityMechanismCheckFailedError",
        LASSO_PROFILE_ERROR_INVALID_ASSERTION_CONDITIONS => "LassoProfileInvalidAssertionConditionsError",
        LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER => "LassoProfileMissingNameIdentifierError",
        LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST_UNSUPPORTED_BY_REQUESTER => "LassoWsfprofileRedirectRequestUnsupportedByRequesterError",
        LASSO_WSSEC_ERROR_BAD_PASSWORD => "LassoWssecBadPasswordError",
        LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL => "LassoLoginUnknownPrincipalError",
        LASSO_PROFILE_ERROR_MISSING_REQUEST => "LassoProfileMissingRequestError",
        LASSO_PROFILE_ERROR_INVALID_ARTIFACT => "LassoProfileInvalidArtifactError",
        LASSO_SOAP_ERROR_MISSING_ENVELOPE => "LassoSoapMissingEnvelopeError",
        LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND => "LassoProfileIdentityNotFoundError",
        LASSO_PROFILE_ERROR_INVALID_MSG => "LassoProfileInvalidMsgError",
        LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE => "LassoProfileUnsupportedProfileError",
        LASSO_PROVIDER_ERROR_MISSING_PUBLIC_KEY => "LassoProviderMissingPublicKeyError",
        LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED => "LassoLoginConsentNotObtainedError",
        LASSO_DST_ERROR_QUERY_FAILED => "LassoDstQueryFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVICE_INSTANCE => "LassoProfileMissingServiceInstanceError",
        LASSO_DST_ERROR_QUERY_NOT_FOUND => "LassoDstQueryNotFoundError",
        LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST => "LassoWsfprofileRedirectRequestError",
        LASSO_DS_ERROR_DECRYPTION_FAILED_MISSING_PRIVATE_KEY => "LassoDsDecryptionFailedMissingPrivateKeyError",
        LASSO_DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE => "LassoDiscoveryFailedToBuildEndpointReferenceError",
        LASSO_DS_ERROR_PUBLIC_KEY_LOAD_FAILED => "LassoDsPublicKeyLoadFailedError",
        LASSO_SERVER_ERROR_INVALID_XML => "LassoServerInvalidXmlError",
        LASSO_PROFILE_ERROR_MISSING_ASSERTION => "LassoProfileMissingAssertionError",
        LASSO_IDWSF2_DST_ERROR_PARTIAL_FAILURE => "LassoIdwsf2DstPartialFailureError",
        LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL => "LassoProfileUnknownProfileUrlError",
        LASSO_PROFILE_ERROR_INVALID_QUERY => "LassoProfileInvalidQueryError",
        LASSO_PROFILE_ERROR_CANNOT_FIND_A_PROVIDER => "LassoProfileCannotFindAProviderError",
        LASSO_DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER => "LassoDefederationMissingNameIdentifierError",
        LASSO_PARAM_ERROR_INVALID_VALUE => "LassoParamInvalidValueError",
        LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED => "LassoDsSignatureVerificationFailedError",
        LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS => "LassoProfileMissingEndpointReferenceAddressError",
        LASSO_DATA_SERVICE_ERROR_UNREGISTERED_DST => "LassoDataserviceUnregisteredDstError",
        LASSO_LOGIN_ERROR_INVALID_SIGNATURE => "LassoLoginInvalidSignatureError",
        LASSO_ASSERTION_QUERY_ERROR_NOT_AN_ATTRIBUTE_QUERY => "LassoAssertionqueryNotAnAttributeQueryError",
        LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST => "LassoLoginUnsignedAuthnRequestError",
        LASSO_SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED => "LassoServerSetEncryptionPrivateKeyFailedError",
        LASSO_DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED => "LassoDsSignatureTmplCreationFailedError",
        LASSO_PROFILE_ERROR_INVALID_ASSERTION => "LassoProfileInvalidAssertionError",
        LASSO_IDWSF2_DISCOVERY_ERROR_NOT_FOUND => "LassoIdwsf2DiscoveryNotFoundError",
        LASSO_DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED => "LassoDiscoverySvcMetadataAssociationAddFailedError",
        LASSO_DS_ERROR_CONTEXT_CREATION_FAILED => "LassoDsContextCreationFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION => "LassoProfileMissingServiceDescriptionError",
        LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID => "LassoProfileMissingRemoteProvideridError",
        LASSO_PARAM_ERROR_NON_INITIALIZED_OBJECT => "LassoParamNonInitializedObjectError",
        LASSO_PROFILE_ERROR_MISSING_RESPONSE => "LassoProfileMissingResponseError",
        LASSO_LOGOUT_ERROR_REQUEST_DENIED => "LassoLogoutRequestDeniedError",
        LASSO_XML_ERROR_MISSING_NAMESPACE => "LassoXmlMissingNamespaceError",
        LASSO_ASSERTION_QUERY_ERROR_ATTRIBUTE_REQUEST_ALREADY_EXIST => "LassoAssertionqueryAttributeRequestAlreadyExistError",
        LASSO_PROFILE_ERROR_MISSING_ARTIFACT => "LassoProfileMissingArtifactError",
        LASSO_WSF_PROFILE_ERROR_MISSING_CORRELATION => "LassoWsfprofileMissingCorrelationError",
        LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH => "LassoServerAddProviderProtocolMismatchError",
        LASSO_PROFILE_ERROR_MISSING_STATUS_CODE => "LassoProfileMissingStatusCodeError",
        LASSO_PROFILE_ERROR_BAD_IDENTITY_DUMP => "LassoProfileBadIdentityDumpError",
        LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED => "LassoProfileBuildingResponseFailedError",
        LASSO_DST_ERROR_MALFORMED_QUERY => "LassoDstMalformedQueryError",
        LASSO_DATA_SERVICE_ERROR_CANNOT_ADD_ITEM => "LassoDataserviceCannotAddItemError",
        LASSO_LOGIN_ERROR_NO_DEFAULT_ENDPOINT => "LassoLoginNoDefaultEndpointError",
        LASSO_PROFILE_ERROR_BAD_SESSION_DUMP => "LassoProfileBadSessionDumpError",
        LASSO_DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE => "LassoDiscoveryMissingRequestedServiceError",
        LASSO_SOAP_ERROR_MISSING_BODY => "LassoSoapMissingBodyError",
        LASSO_SERVER_ERROR_ADD_PROVIDER_FAILED => "LassoServerAddProviderFailedError",
        LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD => "LassoProfileInvalidHttpMethodError",
        LASSO_LOGIN_ERROR_INVALID_ASSERTION_SIGNATURE => "LassoLoginInvalidAssertionSignatureError",
        LASSO_IDWSF2_DST_ERROR_DUPLICATE_ITEM => "LassoIdwsf2DstDuplicateItemError",
        LASSO_IDWSF2_DST_ERROR_ITEM_NOT_FOUND => "LassoIdwsf2DstItemNotFoundError",
        LASSO_IDWSF2_DISCOVERY_ERROR_NO_RESULTS => "LassoIdwsf2DiscoveryNoResultsError",
        LASSO_PROFILE_ERROR_MISSING_ISSUER => "LassoProfileMissingIssuerError",
        LASSO_XML_ERROR_NODE_CONTENT_NOT_FOUND => "LassoXmlNodeContentNotFoundError",
        LASSO_SOAP_ERROR_MISSING_HEADER => "LassoSoapMissingHeaderError",
        LASSO_PROFILE_ERROR_UNKNOWN_ISSUER => "LassoProfileUnknownIssuerError",
    );

    public static function throw_on_rc($rc) {
        $exception = self::$exceptions_dict[$rc];
        if (! class_exists($exception)) {
            $exception = "LassoError";
        }
        throw new $exception(strError($rc), $rc);
    }
}

?>
